#include<bits/stdc++.h>
#define MAXN 350
using namespace std;

const int inf=2e9+7;

struct query{
    int a,b,c,d,id;
};

int n,m,q,aa,bb,cc,dd;
int a[MAXN*MAXN],ans[MAXN*MAXN];
bool inv;

vector<query> tree[4*MAXN];

void update(int v,int l,int r,query s){
    if(l==r){
        tree[v].push_back(s);
        return;
    }

    int tt=(l+r)/2;
    if(s.b<=tt and s.d>tt){
        tree[v].push_back(s);
        return;
    }

    if(s.d<=tt)update(2*v,l,tt,s);
    else update(2*v+1,tt+1,r,s);
}

int dp[MAXN*MAXN];

void calcdp(int from,int to,int row){
    int tt=(from+to)/2;

    for(int i=row;i>=1;i--){
        for(int f=tt;f>=from;f--){
            dp[(i-1)*n+f]=inf;
            if(i<row)dp[(i-1)*n+f]=min(dp[(i-1)*n+f],dp[(i)*n+f]+a[(i-1)*n+f]);
            if(f<tt)dp[(i-1)*n+f]=min(dp[(i-1)*n+f],dp[(i-1)*n+f+1]+a[(i-1)*n+f]);

            if(i==row and f==tt)dp[(i-1)*n+f]=a[(i-1)*n+f];
        }
    }

    for(int i=row;i<=n;i++){
        for(int f=tt+1;f<=to;f++){
            dp[(i-1)*n+f]=inf;
            if(i>row)dp[(i-1)*n+f]=min(dp[(i-1)*n+f],dp[(i-2)*n+f]+a[(i-1)*n+f]);
            if(f>tt+1)dp[(i-1)*n+f]=min(dp[(i-1)*n+f],dp[(i-1)*n+f-1]+a[(i-1)*n+f]);

            if(i==row and f==tt+1)dp[(i-1)*n+f]=a[(i-1)*n+f];
        }
    }
}

void solve(int v,int l,int r){

    for(int i=1;i<=n;i++){
        calcdp(l,r,i);

        for(int f=0;f<tree[v].size();f++){
            if(tree[v][f].a<=i and i<=tree[v][f].c){
                ans[tree[v][f].id]=min(ans[tree[v][f].id] , dp[(tree[v][f].a-1)*n+tree[v][f].b] + dp[(tree[v][f].c-1)*n+tree[v][f].d] );
            }
        }
    }

    if(l==r)return;

    int tt=(l+r)/2;
    solve(2*v,l,tt);
    solve(2*v+1,tt+1,r);
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>m>>q;

   /* if(n>m){
        swap(n,m);
        inv=true;
    }*/

    if(!inv){
        for(int i=1;i<=n;i++){
            for(int f=1;f<=m;f++){
                cin>>a[(i-1)*n+f];
            }
        }
    }else{
        for(int f=1;f<=m;f++){
            for(int i=1;i<=n;i++){
                cin>>a[(i-1)*n+f];
            }
        }
    }

    for(int i=1;i<=q;i++){
        cin>>aa>>bb>>cc>>dd;

        if(inv){
            swap(aa,bb);
            swap(cc,dd);
        }

        update(1,1,m,{aa,bb,cc,dd,i});
        ans[i]=inf;
    }

    solve(1,1,m);

    for(int i=1;i<=q;i++){
        cout<<ans[i]<<"\n";
    }

    return 0;
}
