#include<bits/stdc++.h>
using namespace std;

struct query{
    int a,b,c;
};

int n,m,cnt;
int bucket,root;

int fenwick[100][100];
vector<query> v;
int ans[100][100];

void update(int x,int y){
    int xx=x,yy=y;

    while(x<=n){
        y=yy;
        while(y<=m){
            if(fenwick[x][y]!=0)v.push_back({cnt+1,fenwick[x][y],(xx-1)*m+yy});
            else v.push_back({cnt+1,n*m+1,(xx-1)*m+yy});

            fenwick[x][y]=cnt+1; cnt++;

            y+=(y & (-y));
        }
        x+=(x & (-x));
    }
}

int getsum(int x,int y){
    int curr=n*m+1;

    int xx=x,yy=y;

    while(x>=1){
        y=yy;
        while(y>=1){
            v.push_back({cnt+1,fenwick[x][y],curr});
            cnt++; curr=cnt;

            y-=(y & (-y));
        }
        x-=(x & (-x));
    }

    return curr;
}

int main(){

    cin>>n>>m;

    v.push_back({n*m+1,1,1});
    cnt=n*m+1;

    for(int i=1;i<=n;i++){
        for(int f=1;f<=m;f++){
            update(i,f);
        }
    }

    for(int i=1;i<=n;i++){
        for(int f=1;f<=m;f++){
            ans[i][f]=getsum(i,f);
        }
    }

    cout<<cnt<<"\n";

    for(int i=1;i<=n;i++){
        for(int f=1;f<=m;f++){
            cout<<ans[i][f]<<" ";
        }
        cout<<"\n";
    }

    for(int i=0;i<v.size();i++){
        if(v[i].a<=v[i].b or v[i].a<=v[i].c){
            cout<<1/0;
        }
        if(v[i].a==n*m+1)cout<<v[i].a<<" = "<<v[i].b<<" - "<<v[i].c<<"\n";
        else cout<<v[i].a<<" = "<<v[i].b<<" + "<<v[i].c<<"\n";
    }

    return 0;
}

