#include<bits/stdc++.h>
using namespace std;

struct query{
    int a,b,c;
};

int n,m,cnt;

int fenwick[100][100];
vector<int> s[100][100];

vector<query> v;
int ans[100][100];
vector<int> w;
int root;

int build(int l,int r){
    if(l==r)return w[l];

    int tt=(l+r)/2;
    int aa=build(l,tt);
    int bb=build(tt+1,r);

    if(l==0 and r==w.size()-1){
        v.push_back({root,aa,bb});
        return 0;
    }

    cnt++;
    v.push_back({cnt,aa,bb});
    return cnt;
}

void match(int x,vector<int> children){
    if(children.size()==1){
        v.push_back({x,children[0],n*m+3});
        return;
    }
    w=children; root=x;
    build(0,w.size()-1);
}

void update(int x,int y){
    int xx=x,yy=y;

    while(x<=n){
        y=yy;
        while(y<=m){
            s[x][y].push_back((xx-1)*m+yy);
            y+=(y & (-y));
        }
        x+=(x & (-x));
    }
}

void getsum(int x,int y){
    int xx=x,yy=y;

    while(x>=1){
        y=yy;
        while(y>=1){
            s[xx][yy].push_back(fenwick[x][y]);

            y-=(y & (-y));
        }
        x-=(x & (-x));
    }
}

int main(){

    cin>>n>>m;

    if(n==m and n==1){
        cout<<1<<"\n";
        cout<<1<<"\n";
        return 0;
    }

    v.push_back({n*m+1,1,2});
    v.push_back({n*m+2,1,2});
    v.push_back({n*m+3,n*m+1,n*m+2});

    cnt=n*m+3;

    for(int i=1;i<=n;i++){
        for(int f=1;f<=m;f++){
            update(i,f);
        }
    }

    for(int i=1;i<=n;i++){
        for(int f=1;f<=m;f++){
            if(s[i][f].empty())continue;

            cnt++; fenwick[i][f]=cnt;
            match(fenwick[i][f],s[i][f]);

            s[i][f].clear();
        }
    }

    for(int i=1;i<=n;i++){
        for(int f=1;f<=m;f++){
            getsum(i,f);

            cnt++; ans[i][f]=cnt;
            match(ans[i][f],s[i][f]);
        }
    }

    cout<<cnt<<"\n";

    for(int i=1;i<=n;i++){
        for(int f=1;f<=m;f++){
            cout<<ans[i][f]<<" ";
        }
        cout<<"\n";
    }

    for(int i=0;i<v.size();i++){
       if(v[i].a==n*m+3)cout<<v[i].a<<" = "<<v[i].b<<" - "<<v[i].c<<"\n";

        else cout<<v[i].a<<" = "<<v[i].b<<" + "<<v[i].c<<"\n";
    }

    return 0;
}

