#include "gcdSquared.h"
#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>

typedef long long llong;
const int MAXN = 200000 + 10;
const int INF  = 1e9;

int n;
llong v[MAXN];

void init(int _n, const int _v[])
{
    n = _n;
    for (int i = 1 ; i <= n ; ++i)
    {
        v[i] = _v[i];
    }
}

llong getGCD(int a, int b, int c, int l, int r)
{
    llong res = 0;
    for (int i = l ; i <= r ; ++i)
    {
        res = std::__gcd(res, a * v[i] * v[i] + b * v[i] + c);
    }

    return res;
}