#include <iostream>
#include <vector>
using namespace std;
#define endl '\n'
const int MAXN=1e4+10;
const int MAXP=2e5+10;
vector <int> a;
int res[MAXN][MAXN], pref[MAXP];
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m, q;
    int i1, j1, i2, j2;
    cin >> n >> m >> q;
    if (n==1) {
        int x;
        for (int j=1;j<=m;j++) {
            cin >> x;
            pref[j]=pref[j-1]+x;
        }
        for (int i=0;i<q;i++) {
            cin >> i1 >> j1 >> i2 >> j2;
            cout << pref[j2]-pref[j1-1] << endl;
        }
        return 0;
    }
    a.resize(n*m+1);
    for (int i=1;i<=n;i++) {
        for (int j=1;j<=m;j++) {
            int idx=(i-1)*m+j;
            cin >> a[idx];
        }
    }
    for (int i=1;i<=n;i++) {
        for (int j=1;j<=m;j++) {
            int up=(i-1)*m+j;
            res[up][up]=a[up];
            for (int down=up+1;down<=n*m;down++) {
                if (down-m<up) res[up][down]=res[up][down-1]+a[down];
                else res[up][down]=min(res[up][down-1],res[up][down-m])+a[down];
            }
        }
    }
    for (int i=0;i<q;i++) {
        cin >> i1 >> j1 >> i2 >> j2;
        int up=(i1-1)*m+j1;
        int down=(i2-1)*m+j2;
        cout << res[up][down] << endl;
    }
    return 0;
}
