#include <iostream>
#include <vector>
using namespace std;
const int MAXN=1e2;
struct result {
    int id;
    int ida;
    int idb;
};
int pref[MAXN][MAXN], idx[MAXN][MAXN], fen[MAXN][MAXN], fi[MAXN][MAXN], fj[MAXN][MAXN];
vector <result> ans;
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    int cnt=n*m+1;
    for (int i=1;i<=n;i++) {
        for (int j=1;j<=m;j++) {
            int cur=(i-1)*m+j;
            fen[i][j]=cur;
            int stj=2;
            while (j%stj==0) {
                ans.push_back({cnt,fen[i][j],fen[i][j-(stj>>1)]});
                fen[i][j]=cnt;
                cnt++;
                stj=(stj<<1);
            }
            stj=(stj>>1);

            fj[i][j]=fen[i][j];
            int sti=2;
            while (i%sti==0) {
                ans.push_back({cnt,fj[i][j],fj[i-(sti>>1)][j]});
                fj[i][j]=cnt;
                cnt++;
                sti=(sti<<1);
            }
            sti=(sti>>1);

            if (i==sti && j==stj) idx[i][j]=fj[i][j];
            else if (i==sti) {
                ans.push_back({cnt,fj[i][j],idx[i][j-stj]});
                idx[i][j]=cnt;
                cnt++;
            } else if (j==stj) {
                ans.push_back({cnt,fj[i][j],idx[i-sti][j]});
                idx[i][j]=cnt;
                cnt++;
            } else {
                ans.push_back({cnt,idx[i-sti][j],idx[i][j-stj]});
                ans.push_back({cnt+1,cnt,idx[i-sti][j-stj]});
                ans.push_back({cnt+2,cnt+1,fj[i][j]});
                idx[i][j]=cnt+2;
                cnt+=3;
            }
            //cout << i << ' ' << j << ' ' << pref[i][j] << ' ' << fen[i][j] << ' ' << fi[i][j] << ' ' << st << ' ' << idx[i][j] << endl;
        }
    }
    cout << cnt-1 << endl;
    for (int i=1;i<=n;i++) {
        for (int j=1;j<=m;j++) cout << idx[i][j] << ' ';
        cout << endl;
    }
    for (auto i:ans) {
        cout << i.id << " = " << i.ida << " + " << i.idb << endl;
    }
    return 0;
}
