#include <bits/stdc++.h>
using namespace std;

const int maxn = 1e4+2;
int n, m, q, a[maxn][maxn], dp[maxn][maxn];

void path(int&x1, int&y1, int&x2, int&y2)
{
    dp[x1][y1] = a[x1][y1];
    int i, j;
    i = x1;
    for (j=y1+1; j<=y2; ++j)
        dp[i][j] = dp[i][j-1] + a[i][j];

    j = y1;
    for (i=x1+1; i<=x2; ++i)
        dp[i][j] = dp[i-1][j] + a[i][j];

    for (i=x1+1; i<=x2; ++i)
    {
        for (j=y1+1; j<=y2; ++j)
        {
            dp[i][j] = min(dp[i-1][j], dp[i][j-1]) + a[i][j];
        }
    }
    cout << dp[x2][y2] << '\n' ;
}

void solve()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> m >> q ;
    int i, j;
    for (i=1; i<=n; ++i)
    {
        for (j=1; j<=m; ++j)
        {
            cin >> a[i][j] ;
        }
    }

    int x1, y1, x2, y2;
    for (i=1; i<=q; ++i)
    {
        cin >> x1 >> y1 >> x2 >> y2 ;
        path(x1, y1, x2, y2);
    }
}

int main()
{
    solve();
    return 0;
}