#include <bits/stdc++.h>
#include "gcdSquared.h"
using namespace std;

const int maxn = 2e5+2, maxst = 1e8;
long long d[maxn];
long long del[maxst+1];

void init(int n, const int v[])
{
    long long i;
    for (i=1; i<=n; ++i)
        d[i] = (long long)(v[i]) ;

    del[1] = 1;
    del[2] = 2;
    long long j;
    for (i=1; i<=maxst; ++i)
    {
        j = 2;
        while (j*j <= i && i%j != 0)
            ++ j;

        if (i%j == 0)
            del[i] = j;
        else
            del[i] = i;
    }
}

long long getGCD(int a, int b, int c, int l, int r)
{
    if (l == r)
        return (long long)(b)*d[l] + (long long)(c);

    int i;
    long long dif, x1, x2, nod;
    for (i=l; i<r; ++i)
    {
        dif = (long long)(abs(d[i] - d[i+1])) * (long long)(b);
        x1 = (long long)(b)*d[i] + (long long)(c);
        x2 = (long long)(b)*d[i+1] + (long long)(c);

        while (x1 % dif != 0 || x2 % dif != 0)
        {
            dif = dif / del[dif];
        }
        if (i == l) nod = dif;
        nod = __gcd(nod, dif);
    }
    return nod;
}