#include "gcdSquared.h"
#include<bits/stdc++.h>

using namespace std;

int N;
long long V[200006], tV[200006];
long long tree[800006];
long long tree2[800006];

long long absol(long long t)
{
    if(t<0) return -t;
    return t;
}

long long my_gcd(long long a, long long b)
{
    if(a==0) return b;
    if(b==0) return a;
    return __gcd(a, b);
}

void build_tree(int v, int le, int ri)
{
    if(le==ri) tree[v]=absol(V[le]-V[le+1]);
    else
    {
        int mid=(le+ri)/2;
        build_tree(2*v, le, mid);
        build_tree(2*v+1, mid+1, ri);
        tree[v]=my_gcd(tree[2*v], tree[2*v+1]);
    }
}

void build_tree2(int v, int le, int ri)
{
    if(le==ri)
    {
        if(V[le]!=V[le+1] || V[le+1]!=V[le+2]) tree2[v]=absol((V[le]-V[le+1])*(V[le+1]-V[le+2])/my_gcd((V[le]-V[le+1]), (V[le+1]-V[le+2]))*(V[le]-V[le+2]));
        else tree2[v]=0;
    }
    else
    {
        int mid=(le+ri)/2;
        build_tree2(2*v, le, mid);
        build_tree2(2*v+1, mid+1, ri);
        tree2[v]=my_gcd(tree2[2*v], tree2[2*v+1]);
    }
}

long long query(int v, int le, int ri, int be, int en)
{
    if(le>en || ri<be) return 0;
    if(be<=le && ri<=en) return tree[v];
    int mid=(le+ri)/2;
    return my_gcd(query(2*v, le, mid, be, en), query(2*v+1, mid+1, ri, be, en));
}

long long query2(int v, int le, int ri, int be, int en)
{
    if(le>en || ri<be) return 0;
    if(be<=le && ri<=en) return tree2[v];
    int mid=(le+ri)/2;
    return my_gcd(query2(2*v, le, mid, be, en), query2(2*v+1, mid+1, ri, be, en));
}

void init(int n, const int v[])
{
    for(int i=n; i>=1; i--) V[i]=v[i];
    sort(V+1, V+n+1);
    int br=1;
    tV[1]=V[1];
    for(int i=2; i<=n; i++)
    {
        if(V[i]!=V[i-1])
        {
            br++;
            tV[br]=V[i];
        }
    }
    for(int i=1; i<=br; i++) {V[i]=tV[i];}
    N=br;
    build_tree(1, 1, N-1);
    build_tree2(1, 1, N-2);
}

long long getGCD(int a, int b, int c, int l, int r)
{
    r=N;
    long long a1=a, b1=b, c1=c;
    if(a1==0)
    {
        if(r==l) return b1*V[l]+c1;
        return my_gcd(b1*V[l]+c1, b1*query(1, 1, N-1, l, r-1));
    }
    long long gcd=a1*V[l]*V[l]+b1*V[l]+c1;
    if(r-l<=2)
    {
        for(int i=l+1; i<=r; i++)
        {
            gcd=my_gcd(gcd, a1*V[i]*V[i]+b1*V[i]+c1);
        }
        return gcd;
    }
    gcd=my_gcd(gcd, absol((a1*(V[l]+V[l+1])+b1)*(V[l]-V[l+1])));

    long long t=query2(1, 1, N-2, l, r-2);
    t=my_gcd(t, gcd);
    gcd=my_gcd(gcd, a1*t);
    return gcd;
}
