#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN = 200000 + 2;
vector <long long> a[MAXN];
vector <long long> s[MAXN];
int n, m, q;

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    cin >> n >> m >> q;

    for (int i = 1; i <= n; i++)
    {
        a[i].resize(m+1);
        for (int j = 1; j <= m; j++)
        {
            cin >> a[i][j];
        }
        s[i] = a[i];
    }

    s[0].resize(m+1, 2e9);
    s[0][1] = 0;

    for (int i = 1; i <= n; i++)
    {
        s[i][0] = 2e9;
        for (int j = 1; j <= m; j++)
        {
            s[i][j] = min(s[i-1][j], s[i][j-1]) + a[i][j];
        }
    }

    cerr << "\n\n";
    for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j <= m; j++)
        {
            cerr << s[i][j] << " ";
        } cerr << endl;
    }

    for (int i = 1; i <= q; i++)
    {
        int xs, ys, xt, yt;
        cin >> xs >> ys >> xt >> yt;

        long long ans = s[xt][yt] - s[xs][ys] + a[xs][ys];
        cout << ans << endl;
    }

    return 0;
}

/**
5 5 6
1 2 1 1 1
1 1 3 2 2
1 1 1 1 1
1 3 3 1 1
2 3 3 1 1
1 1 4 4
2 2 5 5
1 1 1 4
1 1 2 4
2 2 4 3
1 1 5 5

*/