#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN = 200000 + 2;
vector <long long> a[MAXN];
vector <vector<vector<long long>>> s;
int n, m, q;

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    cin >> n >> m >> q;

    s.resize(n+2);
    for (int i = 0; i <= n; i++)
        s[i].resize(n+2);

    for (int i = 1; i <= n; i++)
    {
        a[i].resize(m+1);
        for (int j = 1; j <= m; j++)
        {
            cin >> a[i][j];
        }
    }

    for (int beg = 1; beg <= n; beg++)
    {
        for (int i = 1; i <= n; i++)
            s[beg][i] = a[i];
            
        s[beg][0].resize(m+1, 2e9);
        s[beg][0][1] = 0;

        for (int i = 1; i < beg; i++)
            s[beg][i] = s[beg][0];

        for (int i = beg; i <= n; i++)
        {
            s[beg][i][0] = 2e9;
            for (int j = 1; j <= m; j++)
            {
                s[beg][i][j] = min(s[beg][i-1][j], s[beg][i][j-1]) + a[i][j];
            }
        }
    }

    for (int i = 1; i <= q; i++)
    {
        int xs, ys, xt, yt;
        cin >> xs >> ys >> xt >> yt;

        long long ans = s[xs][xt][yt] - s[xs][xs][ys] + a[xs][ys];
        cout << ans << endl;
    }

    return 0;
}

/**
5 5 6
1 2 1 1 1
1 1 3 2 2
1 1 1 1 1
1 3 3 1 1
2 3 3 1 1
1 1 4 4
2 2 5 5
1 1 1 4
1 1 2 4
2 2 4 3
1 1 5 5

*/