#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN = 200000 + 2;
vector <long long> a[MAXN];
vector <vector<vector<vector<long long>>>> s;
int n, m, q;

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    cin >> n >> m >> q;

    s.resize(n+2);
    for (int i = 0; i <= n; i++)
    {
        s[i].resize(m+2);
        for (int j = 0; j <= m; j++)
            s[i][j].resize(n+2);
    }

    for (int i = 1; i <= n; i++)
    {
        a[i].resize(m+1);
        for (int j = 1; j <= m; j++)
        {
            cin >> a[i][j];
        }
    }

    for (int beg = 1; beg <= n; beg++)
    {
        for (int begc = 1; begc <= m; begc++)
        {
            for (int i = 1; i <= n; i++)
                s[beg][begc][i] = a[i];
                
            s[beg][begc][0].resize(m+1, 2e9);
            s[beg][begc][0][begc] = 0;

            for (int i = 1; i < beg; i++)
                s[beg][begc][i] = s[beg][begc][0];

            for (int i = beg; i <= n; i++)
            {
                s[beg][begc][i][begc-1] = 2e9;
                for (int j = begc; j <= m; j++)
                {
                    s[beg][begc][i][j] = min(s[beg][begc][i-1][j], s[beg][begc][i][j-1]) + a[i][j];
                }
            }            
        }
    }

    for (int i = 1; i <= q; i++)
    {
        int xs, ys, xt, yt;
        cin >> xs >> ys >> xt >> yt;

        long long ans = s[xs][ys][xt][yt];
        cout << ans << endl;
    }

    return 0;
}

/**
5 5 6
1 2 1 1 1
1 1 3 2 2
1 1 1 1 1
1 3 3 1 1
2 3 3 1 1
1 1 4 4
2 2 5 5
1 1 1 4
1 1 2 4
2 2 4 3
1 1 5 5

*/