#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

#define int long long

const int MAXN = 200000 + 2;
vector <int> a[MAXN];
vector <vector<int>> s;
int n, m, q;

struct Query 
{
    int num = 0;
    long long answer = 0;
    tuple<int,int,int,int> tup;
    Query() {}
    Query(int _num, tuple<int,int,int,int> _tup)
    {
        num = _num;
        tup = _tup;
    }
};

vector <Query> queries;

bool cmp1(Query a, Query b)
{
    return a.tup < b.tup;
}

bool cmp2(Query a, Query b)
{
    return a.num < b.num;
}

signed main()
{
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    cin >> n >> m >> q;

    
    for (int i = 1; i <= n; i++)
    {
        a[i].resize(m+1);
        for (int j = 1; j <= m; j++)
        {
            cin >> a[i][j];
        }
    }

    for (int i = 1; i <= q; i++)
    {
        int xs, ys, xt, yt;
        cin >> xs >> ys >> xt >> yt;

        queries.push_back(Query(i, {xs, ys, xt, yt}));
    }

    sort(queries.begin(), queries.end(), cmp1);
    int currentQuery = 0;

    for (int beg = 1; beg <= n; beg++)
    {
        for (int begc = 1; begc <= m; begc++)
        {
            if (currentQuery >= q) break;
            int xs, ys, xt, yt; 
            tie(xs, ys, xt, yt) = queries[currentQuery].tup;

            if (beg != xs) continue;
            if (begc != ys) continue;

            s.clear();
            s.resize(n+2);
            for (int i = 1; i <= n; i++)
                s[i] = a[i];
                
            s[0].resize(m+1, 2e9);
            s[0][begc] = 0;

            for (int i = 1; i < beg; i++)
                s[i] = s[0];

            for (int i = beg; i <= n; i++)
            {
                s[i][begc-1] = 2e9;
                for (int j = begc; j <= m; j++)
                {
                    s[i][j] = min(s[i-1][j], s[i][j-1]) + a[i][j];
                }
            }  

            while (xs == beg && ys == begc && currentQuery < q)
            {
                long long ans = s[xt][yt];
                queries[currentQuery].answer = ans;
                currentQuery++;    
                tie(xs, ys, xt, yt) = queries[currentQuery].tup;
            }      
        }
    }

    sort(queries.begin(), queries.end(), cmp2);
    for (int i = 0; i < q; i++)
        cout << queries[i].answer << endl;

    return 0;
}

/**
5 5 6
1 2 1 1 1
1 1 3 2 2
1 1 1 1 1
1 3 3 1 1
2 3 3 1 1
1 1 4 4
2 2 5 5
1 1 1 4
1 1 2 4
2 2 4 3
1 1 5 5

*/