#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}


const int maxq = 2e5 + 10;

struct query
{
    int xs, ys, xt, yt;

    query(int _xs = 0, int _ys = 0, int _xt = 0, int _yt = 0)
    {
        xs = _xs;
        ys = _ys;
        xt = _xt;
        yt = _yt;
    }

    void input()
    {
        cin >> xs >> ys >> xt >> yt;
    }
}task[maxq];


int n, m, q;
vector < vector < int > > a;
vector < vector < vector < vector < int > > > > prec;
void input()
{
    cin >> n >> m >> q;
    a.resize(n + 1);
    a[0].resize(m + 1);
    for (int i = 1; i <= n; i ++)
    {
        a[i].resize(m + 1);
        for (int j = 1; j <= m; j ++)
        {
            cin >> a[i][j];
        }
    }

    for (int i = 1; i <= q; i ++)
    {
        task[i].input();
    }
}

const int inf = 2e9;
vector < vector < int > > dp;
void precompute()
{
    prec.resize(n + 1);
    dp.resize(n + 1);
    for (int i = 0; i <= n; i ++)
    {
        dp[i].resize(m + 1);
        prec[i].resize(m + 1);
        for (int j = 0; j <= m; j ++)
        {
            prec[i][j].resize(n + 1);
            for (int d = 0; d <= n; d ++)
            {
                prec[i][j][d].resize(m + 1);
            }
        }
    }


    for (int i = 1; i <= n; i ++)
        for (int j = 1; j <= m; j ++)
        {

            for (int d = j - 1; d <= m; d ++)
                dp[i - 1][d] = inf;
            for (int d = i - 1; d <= n; d ++)
                dp[d][j - 1] = inf;

            ///cout << "state " << i << " " << j << endl;
            for (int d = i; d <= n; d ++/**, cout << endl*/)
                for (int k = j; k <= m; k ++)
            {
                dp[d][k] = 0;
                if (d != i || j != k)
                {
                    //cout << "to " << d << " " << k << " " << dp[d - 1][k] << " " << dp[d][k - 1] << endl;

                    dp[d][k] = min(dp[d - 1][k], dp[d][k - 1]);
                }

                dp[d][k] += a[d][k];
                prec[i][j][d][k] = dp[d][k];
                //cout << dp[d][k] << " ";
            }
            ///exit(0);
        }
}

void answer_queries()
{
    for (int i = 1; i <= q; i ++)
    {
        cout << prec[task[i].xs][task[i].ys][task[i].xt][task[i].yt] << endl;
    }
}
void solve()
{
    input();
    precompute();
    answer_queries();

}

int main()
{
    speed();
    solve();
    return 0;
}
