#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 66;

struct cell
{
    int idx, lc, rc;
    char type;

    cell(int _idx, int _lc, int _rc, char _type)
    {
        idx = _idx;
        lc = _lc;
        rc = _rc;
        type = _type;
    }
};

const int maxcell = 3e6 + 10;

int n, m;
int p[maxn][maxn];
int value[maxcell * 2];

vector < int > adj[maxn];

bool cycle = false;
int used[maxcell];
void dfs(int v)
{
    used[v] = 1;
    for (int u : adj[v])
    {
        if (used[u] == 1)
        {
            cycle = true;
        }
        else
        if (used[u] == 0)
        {
            dfs(u);
        }
    }

    used[v] = 2;
}

int tk[maxn][maxn];
int dt[maxn][maxn];
int s;
int row_tree[maxn][4 * maxn];
    vector < cell > res;
void build_row(int row, int root, int left, int right)
{
    if (left == right)
    {
        row_tree[row][root] = (row - 1) * m + left;
        return;
    }

    int mid = (left + right) / 2;
    build_row(row, root * 2, left, mid);
    build_row(row, root * 2 + 1, mid + 1, right);

    s ++;
    row_tree[row][root] = s;
    res.push_back(cell(s, row_tree[row][root * 2], row_tree[row][root * 2 + 1], '+'));
}

vector < int > up;
void get_row(int row, int root, int left, int right, int qleft, int qright)
{
    if (left > qright || right < qleft)
        return;

    if (left >= qleft && right <= qright)
    {
        up.push_back(row_tree[row][root]);
        return;
    }

    int mid = (left + right) / 2;
    get_row(row, root * 2, left, mid, qleft, qright);
    get_row(row, root * 2 + 1, mid + 1, right, qleft, qright);
}

int process(vector < int > arr)
{
while(arr.size() > 1)
            {
                vector < int > new_arr;
                int sz = arr.size();
                for (int i = 0; i < sz; i += 2)
                {
                    if (i + 1 == sz)
                        new_arr.push_back(arr[i]);
                    else
                    {
                        s ++;
                        res.push_back(cell(s, arr[i], arr[i + 1], '+'));
                        new_arr.push_back(s);
                        adj[s].push_back(arr[i]);
                        adj[s].push_back(arr[i + 1]);
                    }
                }

                arr = new_arr;
            }

        return arr[0];
}
void solve()
{
    cin >> n >> m;
    s = n * m;

    for (int i = 1; i <= n; i ++)
    {
        build_row(i, 1, 1, m);

        /**tk[i][1] = (i - 1) * m + 1;
        for (int j = 2; j <= m; j ++)
        {
            s ++;
            res.push_back(cell(s, tk[i][j - 1], (i - 1) * m + j, '+'));
            tk[i][j] = s;
        }*/
    }


    for (int i = 1; i <= n; i ++)
    {
        for (int j = 1; j <= m; j ++)
        {
            vector < int > arr;
            for (int d = 1; d <= i; d ++)

            {
                up.clear();
                get_row(i, 1, 1, m, 1, j);
                arr.push_back(process(up));
            }

            ///cout << i << " : " << j << " : " << s / (n * m) << endl;
            ///cout << delta << endl;


            p[i][j] = process(arr);
        }
    }
    ///exit(0);


    cout << s << endl;
    for (int i = 1; i <= n; i ++, cout << endl)
        for (int j = 1; j <= m; j ++)
        cout << p[i][j] << " ";

    for (cell cur : res)
    {
        cout << cur.idx << "=" << cur.lc << cur.type << cur.rc << endl;
    }

}

int main()
{
    ///speed();
    solve();
    return 0;
}
