#include<bits/stdc++.h>
#define endl '\n'
#include "gcdSquared.h"

using namespace std;
typedef long long ll;

const int maxn = 2e5 + 10;

int n, q;
ll v[maxn];
void input()
{
    cin >> n;
    for (int i = 1; i <= n; i ++)
        cin >> v[i];
}

ll d[maxn];
ll tree[4 * maxn];

void build(int root, int left, int right)
{
    if (left == right)
    {
        tree[root] = d[left];
        return;
    }

    int mid = (left + right) / 2;
    build(root * 2, left, mid);
    build(root * 2 + 1, mid + 1, right);

    tree[root] = __gcd(tree[root * 2], tree[root * 2 + 1]);
}

ll get_gcd(int root, int left, int right, int qleft, int qright)
{
    if (left > qright || right < qleft)
        return 0;
    if (left >= qleft && right <= qright)
        return tree[root];

    int mid = (left + right) / 2;
    return __gcd(get_gcd(root * 2, left, mid, qleft, qright),
                 get_gcd(root * 2 + 1, mid + 1, right, qleft, qright));
}

void init(int _n, const int _v[maxn])
{

    n = _n;
    for (int i = 1; i <= n; i ++)
    {
        v[i] = _v[i];
        d[i] = v[i] - v[i + 1]; /// remove later
    }
    build(1, 1, n);

    for (int i = 1; i <= n; i ++)
    {
        d[i] = v[i] - v[i + 1];
    }
}

ll f[maxn];
long long getGCD(int _a, int _b, int _c, int l, int r)
{
    ll a = _a;
    ll b = _b;
    ll c = _c;
    ll gcd = 0;
    if (a != 0)
    {
     for (int j = l; j <= r; j ++)
            gcd = __gcd(a * v[j] * v[j] + b * v[j] + c, gcd);
    }
    else
    {
        for (int j = l; j <= r; j ++)
            f[j] = b * v[j] + c;

        for (int j = l; j < r; j ++)
        {
            f[j] = b * (v[j] - v[j + 1]);
            assert(d[j] == v[j] - v[j + 1]);
        }
        for (int j = l; j <= r; j ++)
            gcd  = __gcd(gcd, f[j]);
        if (gcd < 0)
        gcd *= -1;
        //gcd = abs(get_gcd(1, 1, n, l, r - 1));
        //gcd *= b;
    }

    return gcd;

}

