#include<bits/stdc++.h>
#define endl "\n"
using namespace std;
int n,m,q;
int a[200010];
vector<pair<int,int> > g[200010];
int dist[200010];
int djikstra(int st,int en){
    for(int i=st/m;i<=en/m;i++){
        for(int j=st%m;j<=en%m;j++){
            dist[m*i+j]=2e9+1;
        }
    }
    dist[st]=a[st];
    priority_queue<pair<int,int> > pq;
    pq.push({-dist[st],st});
    while(!pq.empty()){
        int u=pq.top().second;
        int d=-pq.top().first;
        pq.pop();
        for(auto p: g[u]){
            int v=p.first,w=p.second;
            if(v/m>en/m || v%m>en%m) continue;
            if(d+w<dist[v]){
                dist[v]=d+w;
                pq.push({-dist[v],v});
            }
        }
    }
    return dist[en];
}
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin>>n>>m>>q;
    for(int i=0;i<n;i++){
        for(int j=0;j<m;j++){
            cin>>a[i*m+j];
            if(i>0) g[m*(i-1)+j].push_back({m*i+j,a[i*m+j]});
            if(j>0) g[m*i+j-1].push_back({m*i+j,a[i*m+j]});
        }
    }
    while(q--){
        int x1,y1,x2,y2;
        cin>>x1>>y1>>x2>>y2;
        x1--;
        y1--;
        x2--;
        y2--;
        cout<<djikstra(x1*m+y1,x2*m+y2)<<endl;
    }
    return 0;
}
