#include<bits/stdc++.h>
#include "gcdSquared.h"
#define endl "\n"
using namespace std;
unsigned long long N;
unsigned long long A[200010];
unsigned long long sp[200010][20];
unsigned long long GCD(unsigned long long X,unsigned long long Y){
    if(X==0 || Y==0) return max(X,Y);
    return __gcd(X,Y);
}
void sparseTable(){
    for(unsigned long long i=0;i<N-1;i++){
        if(A[i]>A[i+1]) sp[i][0]=A[i]-A[i+1];
        else sp[i][0]=A[i+1]-A[i];
        //cout<<sp[i][0]<<" ";
    }
    //cout<<endl;
    for(unsigned long long i=1;(1<<i)-1<N-1;i++){
        for(unsigned long long j=0;j+(1<<i)-1<N-1;j++){
            sp[j][i]=GCD(sp[j][i-1],sp[j+(1<<(i-1))][i-1]);
            //cout<<sp[j][i]<<" ";
        }
        //cout<<endl;
    }
}
void init(int n, const int v[]){
    N=n;
    for(unsigned long long i=0;i<N;i++){
        A[i]=v[i];
    }
    sparseTable();
}
long long getGCD(int a, int b, int c, int l, int r){
    l--;
    r--;
    if(l==r) return A[l];
    unsigned long long LOG=(unsigned long long)floor(log2(r-l));
    int g=GCD(b,c);
    return g*GCD(GCD(sp[l][LOG],sp[r-(1<<LOG)][LOG]),b/g*A[l]+c/g);
}
/*int main(){
    int xx[10]={512,256,128,64,32,16,8,4,2,1};
    init(10,xx);
    cout<<getGCD(0,1,0,1,1)<<endl;
    cout<<getGCD(0,1,0,1,2)<<endl;
    cout<<getGCD(0,1,0,1,3)<<endl;
    cout<<getGCD(0,1,0,1,4)<<endl;
    cout<<getGCD(0,1,0,1,5)<<endl;
    cout<<getGCD(0,1,0,1,6)<<endl;
    cout<<getGCD(0,1,0,1,7)<<endl;
    cout<<getGCD(0,1,0,1,8)<<endl;
    cout<<getGCD(0,1,0,1,9)<<endl;
    cout<<getGCD(0,1,0,1,10)<<endl;
    return 0;
}*/
