#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

struct Query
{
    int x1,x2;
    int y1,y2;
    int num;
};

const int MAXQ=5e5+5;
const int INF=INT_MAX;

int n,m,q;
vector<vector<int> > a;
vector<vector<int> > dp;
vector<vector<int> > ans;
Query qr[MAXQ];

bool cmp(Query q1,Query q2)
{
    if(q1.x1==q2.x1 && q1.y1==q2.y1)
    {
        if(q1.x2==q2.x2) return q1.y2<q2.y2;
        return q1.x2<q2.x2;
    }
    if(q1.x1==q2.x1) return q1.y1<q2.y1;
    return q1.x1<q2.x1;
}

int main()
{
ios::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

cin>>n>>m>>q;
a.resize(n+1);
for(int i=0;i<=n;i++) a[i].resize(m+1);
dp.resize(n+1);
for(int i=0;i<=n;i++) dp[i].resize(m+1);
for(int i=1;i<=n;i++)
{
    for(int j=1;j<=m;j++) cin>>a[i][j];
}

ans.resize(n*m+1);
for(int i=0;i<=n*m;i++) ans[i].resize(n*m+1-i);

for(int i=1;i<=n;i++)
{
    for(int j=1;j<=m;j++)
    {
        int cur=m*(i-1)+j;
        for(int i1=i;i1<=n;i1++) dp[i1][j-1]=INF;
        for(int j1=j;j1<=m;j1++) dp[i-1][j1]=INF;
        dp[i][j]=a[i][j];
        ans[cur][0]=a[i][j];
        for(int i2=i;i2<=n;i2++)
        {
            for(int j2=j;j2<=m;j2++)
            {
                if(i2==i && j2==j) continue;
                dp[i2][j2]=min(dp[i2-1][j2], dp[i2][j2-1])+a[i2][j2];
                int tmp=m*(i2-1)+j2;
                ans[cur][tmp-cur]=dp[i2][j2];
            }
        }
    }
}

for(int i=0;i<q;i++)
{
    int x1,y1,x2,y2;
    cin>>x1>>y1>>x2>>y2;
    int t1=m*(x1-1)+y1;
    int t2=m*(x2-1)+y2;
    cout<<ans[t1][t2-t1]<<endl;
}

return 0;
}
