#include "gcdSquared.h"
#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const int MAXN=2e5+5;

int n;
int x[MAXN];
int diff[MAXN];

int tree[4*MAXN];

int query(int node,int l,int r,int b,int e)
{
    if(b<=l && r<=e) return tree[node];
    int mid=(l+r)/2;
    int ret=0;
    if(b<=mid) ret=query(2*node,l,mid,b,e);
    if(mid<e) ret=__gcd(ret, query(2*node+1,mid+1,r,b,e));
    return ret;
}

void build(int node,int l,int r)
{
    if(l==r)
    {
        tree[node]=diff[l];
        return;
    }
    int mid=(l+r)/2;
    build(2*node,l,mid);
    build(2*node+1,mid+1,r);
    tree[node]=__gcd(tree[2*node],tree[2*node+1]);
}

void init(int _n, const int v[])
{
    n=_n;
    for(int i=1;i<=n;i++) x[i]=v[i];
    for(int i=1;i<n;i++) diff[i]=abs(x[i]-x[i+1]);

    build(1,1,n-1);
}

long long getGCD(int a, int b, int c, int l, int r)
{
    long long d=query(1,1,n-1,l,r-1);

    long long ans=__gcd(1LL*b*x[l]+c, 1LL*b*d);

    return ans;
}
