#include "gcdSquared.h"
#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const int MAXN=2e5+5;

int n;
int x[MAXN];
int diff[MAXN];
int sum[MAXN];

int tree[4*MAXN];
int tree2[4*MAXN];

ll query(int node,int l,int r,int b,int e)
{
    if(e<l || r<b) return 0;
    if(b<=l && r<=e) return tree[node];
    int mid=(l+r)/2;
    ll ret=__gcd(query(2*node,l,mid,b,e),
                 query(2*node+1,mid+1,r,b,e));
    return ret;
}

ll query2(int node,int l,int r,int b,int e)
{
    if(e<l || r<b) return 0;
    if(b<=l && r<=e) return tree2[node];
    int mid=(l+r)/2;
    ll ret=__gcd(query2(2*node,l,mid,b,e),
                 query2(2*node+1,mid+1,r,b,e));
    return ret;
}

void build(int node,int l,int r)
{
    if(l==r)
    {
        tree[node]=diff[l];
        tree2[node]=sum[l];
        return;
    }
    int mid=(l+r)/2;
    build(2*node,l,mid);
    build(2*node+1,mid+1,r);
    tree[node]=__gcd(tree[2*node],tree[2*node+1]);
    tree2[node]=__gcd(tree2[2*node],tree2[2*node+1]);
}

void init(int _n, const int v[])
{
    n=_n;
    for(int i=1;i<=n;i++) x[i]=v[i];
    for(int i=1;i<n;i++) diff[i]=abs(x[i]-x[i+1]);
    for(int i=1;i<n;i++) sum[i]=abs(x[i]+x[i+1]);

    build(1,1,n-1);
}

long long getGCD(int a, int b, int c, int l, int r)
{
    ll t=query2(1,1,n-1,l,r-1);
    t=__gcd(1LL*a*x[l]*x[l]+1LL*b*x[l]+c, 1LL*a*t);

    long long d=query(1,1,n-1,l,r-1);

    long long ans=__gcd(1LL*a*x[l]*x[l]+1LL*b*x[l]+c, 1LL*t*d);

    return ans;
}
