#include <bits/stdc++.h>
using namespace std;
int N, M, Q;
const int MAX_SIZE = 200000;
int arr[MAX_SIZE];
int prefixSum[MAX_SIZE];
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> N >> M >> Q;
    for (int i = 0; i < N * M; i++) {
        cin >> arr[i];
    }

    if(N == 1) {
        prefixSum[0] = arr[0];
        for(int i = 1; i < N * M; i++) {
            prefixSum[i] = prefixSum[i - 1] + arr[i];
        }
        for(int i = 0; i < Q; i++) {
            int xs, ys, xt, yt;
            cin >> xs >> ys >> xt >> yt;
            xs--;
            ys--;
            xt--;
            yt--;
            if(ys == 0) {
                cout << prefixSum[yt];
            }
            else
            {
                cout << prefixSum[yt] - prefixSum[ys - 1];
            }
            cout << endl;
        }
        return 0;
    }

    for(int i = 0; i < Q; i++) {
        int xs, ys, xt, yt;
        cin >> xs >> ys >> xt >> yt;
        xs--;
        ys--;
        xt--;
        yt--;
        int dpRows = xt - xs + 1;
        int dpCols = yt - ys + 1;
        int dp[dpRows][dpCols];
        for(int i = 0; i < dpRows; i++) {
            for(int j = 0; j < dpCols; j++) {
                dp[i][j] = 0;
            }
        }

        dp[dpRows - 1][dpCols - 1] = arr[xt * M + yt];
        for(int i = dpCols - 2; i >= 0; i--) {
            dp[dpRows - 1][i] = dp[dpRows - 1][i + 1] + arr[(xs + dpRows - 1) * M + ys + i];
        }
        for(int i = dpRows - 2; i >= 0; i--) {
            dp[i][dpCols - 1] = dp[i + 1][dpCols - 1] + arr[(xs + i) * M + ys + dpCols - 1];
        }
        for(int i = dpRows - 2; i >= 0; i--) {
            for(int j = dpCols - 2; j >= 0; j--) {
                dp[i][j] = arr[(xs + i) * M + ys + j] + min(dp[i + 1][j], dp[i][j + 1]);
                //[xs + i][ys + j]
            }
        }
        cout << dp[0][0] << endl;
    }
    return 0;
}
