#include <bits/stdc++.h>
using namespace std;
int N, M;
const int MAX_N = 64;
const int MAX_M = 64;
int prefix[MAX_N][MAX_M];
struct Node {
    int left;
    int right;
    bool isPlus;
    int number;
};
vector<Node> v;
int main() {
    cin >> N >> M;
    for(int i = 0; i < N * M; i++) {
        Node currNode;
        currNode.isPlus = true;
        currNode.left = 0;
        currNode.right = 0;
        currNode.number = i + 1;
        v.push_back(currNode);
    }
    prefix[0][0] = 1;
    for(int i = 1; i < N; i++) {
        Node newNode;
        newNode.left = prefix[i - 1][0];
        newNode.right = ((i + 1) - 1) * M + 1;
        newNode.isPlus = true;
        newNode.number = v.size() + 1;
        v.push_back(newNode);
        prefix[i][0] = newNode.number;
    }
    for(int i = 1; i < M; i++) {
        Node newNode;
        newNode.left = prefix[0][i - 1];
        newNode.right = i + 1;
        newNode.isPlus = true;
        newNode.number = v.size() + 1;
        v.push_back(newNode);
        prefix[0][i] = newNode.number;
    }

    for(int i = 1; i < N; i++) {
        for(int j = 1; j < M; j++) {
            Node nodeToSumPrefixes;
            nodeToSumPrefixes.left = prefix[i][j - 1];
            nodeToSumPrefixes.right = prefix[i - 1][j];
            nodeToSumPrefixes.isPlus = true;
            nodeToSumPrefixes.number = v.size() + 1;
            v.push_back(nodeToSumPrefixes);

            Node nodeToAddCurrNumber;
            nodeToAddCurrNumber.left = nodeToSumPrefixes.number;
            nodeToAddCurrNumber.right = ((i + 1) - 1) * M + j + 1;
            nodeToAddCurrNumber.isPlus = true;
            nodeToAddCurrNumber.number = v.size() + 1;
            v.push_back(nodeToAddCurrNumber);

            Node nodeToCalcPrefix;
            nodeToCalcPrefix.left = nodeToAddCurrNumber.number;
            nodeToCalcPrefix.right = prefix[i - 1][j - 1];
            nodeToCalcPrefix.isPlus = false;
            nodeToCalcPrefix.number = v.size() + 1;
            v.push_back(nodeToCalcPrefix);
            prefix[i][i] = nodeToCalcPrefix.number;
        }
    }

    cout << v.size() << endl;
    for(int i = 0; i < N; i++) {
        for(int j = 0; j < M; j++) {
            cout << prefix[i][j] << " ";
        }
        cout << endl;
    }
    for(int i = N * M; i < v.size(); i++) {
        cout << v[i].number << " = " << v[i].left;
        if(v[i].isPlus) {
            cout << " + ";
        }
        else
        {
            cout << " - ";
        }
        cout << v[i].right << endl;
    }
    return 0;
}
