#include "gcdSquared.h"
#include <bits/stdc++.h>
using namespace std;

const int MAX_N = 200007;
int varr[MAX_N];
int N;

void init(int n, const int v[]);

long long getGCD(int a, int b, int c, int l, int r);

long long f(int a, int b, int c, int x)
{
    return a * x * x + b * x + c;
}

long long gcd(long long a, long long b) {
    if(a < b) {
        swap(a, b);
    }
    if(a % b == 0 || b % a == 0) {
        return min(a, b);
    }
    return gcd(min(a, b), a % b);
}

void init(int n, const int v[])
{
    N = n;
    for(int i = 0; i < n; i++)
    {
        //cout << "v[i]: " << v[i] << endl;
        varr[i] = v[i] + 1;
    }
}

long long getGCD(int a, int b, int c, int l, int r)
{
    l--;
    r--;
    long long gcdRes = a * varr[l] * varr[l] + b * varr[l] + c;
    for(int i = l + 1; i <= r; i++)
    {
        //cout << f(a, b, c, varr[i]) << endl;
        gcdRes = gcd(gcdRes, (long long)a * varr[i] * varr[i] + b * varr[i] + c);
    }
    return gcdRes;
}
/*
5
1 2 3 4 5
2
1 2 3 4 5
4 2 2 2 3
*/

