#include <iostream>
using namespace std;
const int MAXN = 2 * 1e5 + 1;
const int INF = 1e9 + 7;
int arr[MAXN];
struct Ver{
    int val;
    int lazy;
};
Ver tree[4 * MAXN];
void build(int curr, int from, int to) {
    if (from == to) {
        tree[curr].val = arr[from];
        tree[curr].lazy = 0;
    } else {
        build(curr * 2, from, (from + to) / 2);
        build(curr * 2 + 1, (from + to) / 2 + 1, to);
        tree[curr].val = tree[curr * 2].val + tree[curr * 2 + 1].val;
        tree[curr].lazy = 0;
    }
}
//inline void push(int curr, int from, int to) {
//    if (tree[curr].lazy == 0) {
//        return;
//    }
//    tree[curr * 2].lazy += tree[curr].lazy;
//    tree[curr * 2 + 1].lazy += tree[curr].lazy;
//    tree[curr].val += tree[curr].lazy;
//    tree[curr].lazy = 0;
//}
//void update(int curr, int from, int to, const int l, const int r, const int value) {
//    push(curr, from, to);
//    if (l <= from && to <= r) {
//        tree[curr].lazy += value;
//        push(curr, from, to);
//    }
//    if (l <= to && from <= r) {
//        update(curr * 2, from, (from + to) / 2, l, r, value);
//        update(curr * 2 + 1, (from + to) / 2 + 1, to, l, r, value);
//        tree[curr].val = tree[curr * 2].val + tree[curr * 2 + 1].val;
//    }
//}
int query(int curr, int from, int to, const int l, const int r) {
//    push(curr, from, to);
    if (l <= from && to <= r) {
        return tree[curr].val;
    }
    if (l <= to && from <= r) {
        return query(curr * 2, from, (from + to) / 2, l, r) + query(curr * 2 + 1, (from + to) / 2 + 1, to, l, r);
    }
    return 0;
}
void solve() {
    int n, m, q;
    cin >> m >> n >> q;
    for (int x = 1; x <= n; x++) {
        cin >> arr[x];
    }
    build(1, 1, n);
    while (q --> 0) {
        int xs, ys, xt, yt;
        cin >> ys >> xs >> yt >> xt;
        cout << query(1, 1, n, xs, xt) << '\n';
    }
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}

