#include <iostream>
using namespace std;
const int MAXMN = 1e4 + 1;
int table[MAXMN];
int ans[MAXMN][MAXMN];
void solve() {
    int n, m, q;
    cin >> m >> n >> q;
    for (int y = 1; y <= m; y++) {
        for (int x = 1; x <= n; x++) {
            int curr = x + (y - 1) * n;
            cin >> table[curr];
            ans[curr][curr] = 0;
            if (x == 1 && y == 1) {
                continue;
            }
            if (y == 1) {
                for (int s = 1; s < x; s++) {
                    ans[s][curr] = ans[s][curr - 1] + table[curr];
                }
                continue;
            }
            if (x == 1) {
                for (int t = 1; t < y; t++) {
                    ans[1 + (t - 1) * n][curr] = ans[1 + (t - 1) * n][curr - n] + table[curr];
                }
                continue;
            }

            for (int s = 1; s < x; s++) {
                ans[s + (y - 1) * n][curr] = ans[s + (y - 1) * n][curr - 1] + table[curr];
            }
            for (int t = 1; t < y; t++) {
                ans[x + (t - 1) * n][curr] = ans[x + (t - 1) * n][curr - n] + table[curr];
            }
            for (int t = 1; t < y; t++) {
                for (int s = 1; s < x; s++) {
                    ans[s + (t - 1) * n][curr] = min(ans[s + (t - 1) * n][curr - 1], ans[s + (t - 1) * n][curr - n]) + table[curr];
                }
            }
        }
    }
    while (q --> 0) {
        int xs, ys, xt, yt;
        cin >> ys >> xs >> yt >> xt;
        cout << ans[xs + (ys - 1) * n][xt + (yt - 1) * n] + table[xs + (ys - 1) * n] << '\n';
    }
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}
