#include <iostream>
#include "gcdSquared.h"
using namespace std;
const int MAXN = 1e4 + 1;
const int INF = 1e9 + 7;
long long arr[MAXN];
int len;
void init(int n, const int v[]) {
    for (int i = 1; i <= n; i++) {
        arr[i] = v[i - 1];
    }
    len = n;
}
long long gcd(int a, int b) {
    if (a < b) {
        swap(a, b);
    }
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}
long long getGCD(int a, int b, int c, int l, int r) {
    long long ans = 0;
    for (int i = l; i <= r; i++) {
        ans = gcd(ans, a * arr[i] * arr[i] + b * arr[i] + c);
    }
    return ans;
}

