#include <iostream>
using namespace std;

const int maxm=40004;
const int maxn=6;
long long table[maxn][maxm];

long long prefix[maxn][maxm];

int xs, ys, xt, yt;
int n, m;

long long zero()
{
    return prefix[xt][yt]-prefix[xs][ys-1];
}
long long one()
{
    long long mini=table[xs][ys]+prefix[xt][yt]-prefix[xs+1][ys-1];
    long long curr;
    for(int i=ys+1; i<=yt; i++)
    {
        curr=prefix[xs][i]-prefix[xs][ys-1]+prefix[xt][yt]-prefix[xs+1][i-1];
        //cout << "****" << i << " " << curr << endl;
        if(curr<mini)
        {
            mini=curr;
        }
    }
    return mini;
}

long long two()
{
    long long mini=table[xs][ys]+prefix[xt][yt]-prefix[xs+1][ys-1];
    long long curr;

    for(int i=ys; i<=yt; i++)
    {
        for(int j=i; j<=yt; j++)
        {
            curr=prefix[xs][i]-prefix[xs][ys-1]+prefix[xs+1][j]-prefix[xs+1][i-1]+prefix[xt][yt]-prefix[xs+2][j-1];
            //cout << "****" << i << " " << j << " " << curr << endl;
            if(curr<mini)
            {
                mini=curr;
            }
        }
    }
    return mini;
}

long long three()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    long long mini=table[xs][ys]+prefix[xt][yt]-prefix[xs+1][ys-1];
    long long curr;

    for(int i=ys; i<=yt; i++)
    {
        for(int j=i; j<=yt; j++)
        {
            for(int h=j; h<=yt;  h++)
            {
                curr=prefix[xs][i]-prefix[xs][ys-1]+prefix[xs+1][j]-prefix[xs+1][i-1]+prefix[xs+2][h]-prefix[xs+2][j-1]+prefix[xt][yt]-prefix[xs+3][h-1];
                //cout << "****" << i << " " << j << " " << h << " " << curr << endl;
                if(curr<mini)
                {
                    mini=curr;
                }
            }
        }
    }
    return mini;
}
long long four()
{
    long long mini=table[xs][ys]+prefix[xt][yt]-prefix[xs+1][ys-1];
    long long curr;

    for(int i=ys; i<=yt; i++)
    {
        for(int j=i; j<=yt; j++)
        {
            for(int h=j; h<=yt;  h++)
            {
                for(int f=j; f<=yt; f++)
                {
                    curr=prefix[xs][i]-prefix[xs][ys-1]+prefix[xs+1][j]-prefix[xs+1][i-1]+prefix[xs+2][h]-prefix[xs+2][j-1]+prefix[xs+3][f]-prefix[xs+3][h-1]+prefix[xt][yt]-prefix[xs+4][f-1];
                    if(curr<mini)
                    {
                        mini=curr;
                    }
                }
            }
        }
    }
    return mini;
}

int main()
{

    cin >> n >> m;

    int q;
    cin >> q;

    for(int i=1; i<=n; i++)
    {
        for(int j=1; j<=m; j++)
        {
            cin >> table[i][j];
        }
    }

    for(int i=1; i<=n; i++)
    {
        prefix[i][1]=table[i][1];

        for(int j=2; j<=m; j++)
        {
            prefix[i][j]=prefix[i][j-1]+table[i][j];
        }
    }


    for(int i=0; i<q; i++)
    {
        cin >> xs >> ys >> xt >> yt;
        if(xs==xt)
        {
            cout << zero() << endl;
        }
        else if(xt-xs==1)
        {
            cout << one() << endl;
        }
        else if(xt-xs==2)
        {
            cout << two() << endl;
        }
        else if(xt-xs==3)
        {
            cout << three() << endl;
        }
        else if(xt-xs==4)
        {
            cout << four() << endl;
        }
    }



    return 0;
}
