#include <iostream>
#include "gcdSquared.h"
#define MAX_N 200005
using namespace std;

long long int nums[MAX_N];
int m;

long long gcd(long long a, long long b)
{
    while(a>0 && b>0)
    {
        if(a>=b)
        {
            a=a%b;
        }
        else if(b>a)
        {
            b=b%a;
        }
    }
    return max(a, b);
}

void init(int n, const int v[])
{
    m=n;
    for(int i=1; i<=n; i++)
    {
        nums[i]=v[i];
    }
}

long long getGCD(int a, int b, int c, int l, int r)
{
    long long currgcd;
    long long nextnum;

    currgcd=nums[l]*b+c;

    for(int i=l+1; i<=r; i++)
    {
        //cout << "&&&" << i << endl;
        nextnum=nums[i]*b+c;
        //cout << "***" << nextnum << endl;
        currgcd=gcd(nextnum, currgcd);
        //cout << currgcd << endl;
    }
    return currgcd;
}
