#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

int n,m,q;
vector<vector<int> >a;
vector<vector<int> >dp;

void solve(int xa, int ya, int xb, int yb)
{
    dp[xa][ya] = a[xa][ya];
    for(int i = xa+1; i <= xb; i++) dp[i][ya] = dp[i-1][ya] + a[i][ya];
    for(int j = ya+1; j <= yb; j++) dp[xa][j] = dp[xa][j-1] + a[xa][j];

    for(int i = xa+1; i <= xb; i++)
    {
        for(int j = ya+1; j <= yb; j++)
        {
            dp[i][j] = min(dp[i-1][j],dp[i][j-1]) + a[i][j];
        }
    }
    cout << dp[xb][yb] << endl;
}

void read()
{
    cin >> n >> m >> q;

    a.resize(n+1);
    dp.resize(n+1);
    for(int i = 0; i <= n; i++)
    {
        a[i].resize(m+1);
        dp[i].resize(m+1);
    }

    int xa,ya, xb,yb;

    for(int i = 1; i <= n; i++)
    {
        for(int j = 1; j <= m; j++)
        {
            cin >> xa;
            a[i][j] = xa;
        }
    }

    for(int i = 1; i <= q; i++)
    {
        cin >> xa >> ya >> xb >> yb;
        solve(xa,ya,xb,yb);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    return 0;
}
