#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

struct tab
{
    vector<vector<int>>t;
};

int n,m,q;
vector<vector<int> >a;
vector<vector<tab> >ans;

tab solve(int xa, int ya)
{
    tab dp;

    dp.t.resize(n+1);
    for(int i = 0; i <= n; i++) dp.t[i].resize(m+1);

    dp.t[xa][ya] = a[xa][ya];
    for(int i = xa+1; i <= n; i++) dp.t[i][ya] = dp.t[i-1][ya] + a[i][ya];
    for(int j = ya+1; j <= m; j++) dp.t[xa][j] = dp.t[xa][j-1] + a[xa][j];

    for(int i = xa+1; i <= n; i++)
    {
        for(int j = ya+1; j <= m; j++)
        {
            dp.t[i][j] = min(dp.t[i-1][j],dp.t[i][j-1]) + a[i][j];
        }
    }
    return dp;
}

void read()
{
    cin >> n >> m >> q;

    a.resize(n+1);
    ans.resize(n+1);
    for(int i = 0; i <= n; i++)
    {
        a[i].resize(m+1);
        ans[i].resize(m+1);
    }

    int xa,ya, xb,yb;

    for(int i = 1; i <= n; i++)
    {
        for(int j = 1; j <= m; j++)
        {
            cin >> xa;
            a[i][j] = xa;
        }
    }

    for(int i = 1; i <= n; i++)
    {
        for(int j = 1; j <= m; j++)
        {
            ans[i][j] = solve(i,j);
        }
    }

    for(int i = 1; i <= q; i++)
    {
        cin >> xa >> ya >> xb >> yb;
        cout << ans[xa][ya].t[xb][yb] << endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    return 0;
}
