#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

struct tab
{
    vector<vector<int>>t;
};

int n,m,q;
vector<vector<int> >a;
vector<vector<tab> >ans;

tab solve(int xa, int ya)
{
    tab dp;

    dp.t.resize(n-xa+1);
    for(int i = 0; i < n-xa+1; i++) dp.t[i].resize(m-ya+1);

    dp.t[0][0] = a[xa][ya];
    for(int i = 1; i < n-xa+1; i++) dp.t[i][0] = dp.t[i-1][0] + a[i+xa][ya];
    for(int j = 1; j < m-ya+1; j++) dp.t[0][j] = dp.t[0][j-1] + a[xa][j+ya];

    for(int i = 1; i < n-xa+1; i++)
    {
        for(int j = 1; j < m-ya+1; j++)
        {
            dp.t[i][j] = min(dp.t[i-1][j],dp.t[i][j-1]) + a[i+xa][j+ya];
        }
    }
    return dp;
}

void read()
{
    cin >> n >> m >> q;

    a.resize(n+1);
    ans.resize(n+1);
    for(int i = 0; i <= n; i++)
    {
        a[i].resize(m+1);
        ans[i].resize(m+1);
    }

    int xa,ya, xb,yb;

    for(int i = 1; i <= n; i++)
    {
        for(int j = 1; j <= m; j++)
        {
            cin >> xa;
            a[i][j] = xa;
        }
    }

    for(int i = 1; i <= n; i++)
    {
        for(int j = 1; j <= m; j++)
        {
            ans[i][j] = solve(i,j);
        }
    }

    for(int i = 1; i <= q; i++)
    {
        cin >> xa >> ya >> xb >> yb;
        cout << ans[xa][ya].t[xb-xa][yb-ya] << endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    return 0;
}
