#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

struct tab
{
    long long t[5][5];
};

const int maxm = 2*1e5+1;

int n,m,q;
vector<vector<int> >a;
tab tree[4*maxm];

int ql,qr;
tab inf_check;

void print(int v, int l, int r)
{
    cout << v << " " << l << " " << r << "+++++++++" endl;
    for(int i = 0; i < n; i++)
    {
        for(int j = 0; j < n; j++)
        {
            cout << tree[v].t[i][j] << " ";
        }
        cout << endl;
    }
}

tab combine(tab tl, tab tr)
{
    if(tl.t[0][0]==2e9+2) return tr;
    if(tr.t[0][0]==2e9+2) return tl;
    tab ans;
    for(int i = 0; i < n; i++)
    {
        for(int j = i; j < n; j++)
        {
            ans.t[i][j] = 2e9+1;
            for(int k = i; k <= j; k++)
            {
                ans.t[i][j] = min(ans.t[i][j],tl.t[i][k]+tr.t[k][j]);
            }
        }
    }
    return ans;
}

void make_tree(int v, int l, int r)
{
    if(l==r)
    {
        for(int i = 0; i < n; i++)
        {
            tree[v].t[i][i] = a[i][r];
            for(int j = i+1; j < n; j++) tree[v].t[i][j] = tree[v].t[i][j-1] + a[j][r];
        }

        ///print(v,l,r);
        return;
    }
    int mid = (l+r)/2;
    make_tree(v*2+0,l,mid+0);
    make_tree(v*2+1,mid+1,r);
    tree[v] = combine(tree[v*2+0],tree[v*2+1]);
    ///print(v,l,r);
}

tab query(int v, int l, int r)
{
    if(r<ql||qr<l||l>r) return inf_check;
    if(ql<=l&&r<=qr) return tree[v];
    int mid = (l+r)/2;
    return combine(query(v*2+0,l,mid+0),query(v*2+1,mid+1,r));
}

void read()
{
    cin >> n >> m >> q;

    a.resize(n);
    for(int i = 0; i < n; i++) a[i].resize(m);

    int xa,ya, xb,yb;

    for(int i = 0; i < n; i++)
    {
        for(int j = 0; j < m; j++)
        {
            cin >> xa;
            a[i][j] = xa;
        }
    }

    make_tree(1,0,m-1);

    inf_check.t[0][0] = 2e9+2;

    for(int i = 1; i <= q; i++)
    {
        cin >> xa >> ya >> xb >> yb;
        xa--;
        ya--;
        xb--;
        yb--;
        ql = ya;
        qr = yb;
        tab ans = query(1,0,m-1);
        cout << ans.t[xa][xb] << endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    return 0;
}
