#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

struct vertex
{
    int num,l,r;
    bool oper;
    vertex()
    {
        oper = true;
    }
    vertex(int ni, int li, int ri, bool oi)
    {
        num = ni;
        l = li;
        r = ri;
        oper = oi;
    }
};

const int maxn = 70;

int n,m,idx;
int tab[maxn][maxn];
vector<vertex>ans;


vector<int> coloni[maxn][7];
int prefc[maxn][maxn];

vector<int> redove[maxn][7];
int prefr[maxn][maxn];


void print()
{
    for(vertex nb : ans)
    {
        cout << nb.num << " = " << nb.l;
        if(nb.oper==true) cout << " + ";
        else cout << " - ";
        cout << nb.r << endl;
    }
}

void read()
{
    cin >> n >> m;
    for(int i = 1; i <= n; i++)
    {
        for(int j = 1; j <= m; j++)
        {
            tab[i][j] = ++idx;
        }
    }
}

void make_col(int col)
{
    for(int i = 1; i <= n; i++) coloni[col][0].push_back(tab[i][col]);///originalni vrhove

    for(int j = 1; j < 7; j++)
    {
        int last = 1;
        int p = 0;
        while(last+(1<<j)-1 <= n)
        {
            coloni[col][j].push_back(++idx);
            ans.push_back({idx,coloni[col][j-1][p],coloni[col][j-1][p+1],true});
            last += (1<<j);
            p += 2;
        }
    }

    for(int i = 1; i <= n; i++)
    {
        int x = i;
        int minalo = 0;
        vector<int>pom;
        for(int j = 6;  j >= 0; j--)
        {
            if(x<(1<<j)) continue;
            pom.push_back(coloni[col][j][minalo/(1<<j)]);
            x -= (1<<j);
            minalo += (1<<j);
        }

        for(int j = pom.size()-1; j > 0; j--)
        {
            ans.push_back({++idx,pom[j-1],pom[j],true});
            pom[j-1] = idx;
        }
        prefc[i][col] = pom[0];
    }
}

void make_vsi(int red)
{
    for(int j = 1; j <= m; j++) redove[red][0].push_back(prefc[red][j]);

    for(int j = 1; j < 7; j++)
    {
        int last = 1;
        int p = 0;
        while(last+(1<<j)-1 <= m)
        {
            redove[red][j].push_back(++idx);
            ans.push_back({idx,redove[red][j-1][p],redove[red][j-1][p+1],true});
            last += (1<<j);
            p += 2;
        }
    }

    for(int i = 1; i <= m; i++) ///prosto ne smenih bukvata (i->i)
    {
        int x = i;
        int minalo = 0;
        vector<int>pom;
        for(int j = 6;  j >= 0; j--)
        {
            if(x<(1<<j)) continue;
            pom.push_back(redove[red][j][minalo/(1<<j)]);
            x -= (1<<j);
            minalo += (1<<j);
        }

        for(int j = pom.size()-1; j > 0; j--)
        {
            ans.push_back({++idx,pom[j-1],pom[j],true});
            pom[j-1] = idx;
        }
        prefr[red][i] = pom[0];
    }
}

void solve()
{
    for(int j = 1; j <= m; j++) make_col(j);
    for(int i = 1; i <= n; i++) make_vsi(i);

    cout << idx << endl;
    for(int i = 1; i <= n; i++)
    {
        for(int j = 1; j <= m; j++)
        {
            cout << prefr[i][j] << " ";
        }
        cout << endl;
    }
    print();
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    solve();
    return 0;
}
