#include "gcdSquared.h"
///#include "Lgrader.cpp"
#include <algorithm>
#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 200000;

int sz;
vector<int> vec;
int n, num[MAXN + 5];

void init(int N, const int v[])
{
    n = N;
    for (int i = 1; i <= n; ++ i)
    {
        num[i] = v[i];
        vec.push_back(v[i]);
    }

    sort(vec.begin(), vec.end());
    auto it = unique(vec.begin(), vec.end());
    vec.resize(distance(vec.begin(), it));
    random_shuffle(vec.begin(), vec.end());
    sz = vec.size();
    sz = min(sz, 1500);
}

long long getGCD(int a, int b, int c, int l, int r)
{
    long long ret = 0;
    for (int i = 0; i < sz; ++ i)
    {
        int x = vec[i];
        ret = __gcd(ret, 1ll * a * x * x + 1ll * b * x + c);
    }
    return ret;
}
