#include <bits/stdc++.h>
using namespace std;

#ifndef LOCAL
#define cerr if(false) cerr
#endif // LOCAL

template< class T, class T2 > inline bool chkmin( T& a, const T2& b ){ return a > b ? a = b, 1 : 0; }

#define out(x) "x" << " = " << x << "  "

typedef long long ll;
typedef long double ld;

const int MAX_N = 1e6 + 42;
const int mod = 1e9 + 7;

int x1, x2;
int Y1, y2;
int n, m, q;

std::vector< std::vector< int > > dp;
std::vector< std::vector< int > > a;

void sol( ){
    dp[x1][Y1] = a[x1][Y1];
    cerr << out( x1 ) << out( Y1 ) << out( dp[x1][Y1] ) << endl;
    for( int i = x1 ; i <= x2 ; i++ ){
        for( int j=Y1 ; j <= y2 ; j++ ){
            if( i == x1 and j == Y1 ) continue;
            dp[i][j] = mod;
            if( i != x1 )chkmin( dp[i][j], dp[i-1][j] );
            if( j != Y1 ) chkmin( dp[i][j], dp[i][j-1] );
            dp[i][j] += a[i][j];
            //cerr << dp[i][j] << " ";
        }
        //cerr << endl;
    }
    //cerr << endl << endl;
}

int pref[MAX_N];
std::map< std::pair< std::pair< int, int >, std::pair< int, int > >, int > mm;

int main (){

#ifndef LOCAL
    std::ios_base::sync_with_stdio( false ); std::cin.tie(nullptr); std::cout.tie(nullptr);
#endif // LOCAL

    std::cin >> n >> m >> q;
    dp.resize( n );
    for( int i=0 ; i < n ; i++ ) dp[i].resize( m );

    a.resize( n );
    for( int i=0 ; i < n ; i++ ) a[i].resize( m );


    for( int i=0 ; i < n ; i++ ){
        for( int j=0 ; j < m ; j++ ){
            std::cin >> a[i][j];
        }
    }


    while( q --> 0 ){
        std::cin >> x1 >> Y1 >> x2 >> y2;
        x1 --; Y1--; x2--; y2--;

        std::pair< std::pair< int, int >, std::pair< int, int > > curr = {{x1, Y1}, {x2, y2}};
        if( mm[curr] == 0 ){
            sol();
            mm[curr] = dp[x2][y2];
        }
        std::cout << mm[curr] << endl;
    }


    return 0;
}