#include <bits/stdc++.h>
using namespace std;

#ifndef LOCAL
#define cerr if(false) cerr
#endif // LOCAL

#define out(x) " x " << " = " << x << "  "

typedef long long ll;
typedef long double ld;

const int MAX_N = 128;
const int MAX_LOG = 8;

const int mod = 1e9 + 7;

int reff[MAX_N][MAX_N];
int node[MAX_N][MAX_N][MAX_LOG][MAX_LOG];
int num;
int pw[16];

int main (){

#ifndef LOCAL
    std::ios_base::sync_with_stdio( false ); std::cin.tie(nullptr); std::cout.tie(nullptr);
#endif // LOCAL

    int n, m;
    std::cin >> n >> m;
    num = n * m;

    if( n == m and n == 1 ){
        std::cout << 1 << endl << 1 << endl;
        return 0;
    }

    std::vector< std::pair< std::pair< int, char >, std::pair< int, int > > > nas;

    pw[0] = 1;
    for( int i=1 ; i < 10 ; i++ ){
        pw[i] = pw[i-1] << 1;
    }

    cerr << out( pw[9] ) << endl;

    for( int lgX = 0 ; pw[lgX] <= n ; lgX++ ){
        for( int lgY = 0 ; pw[lgY] <= m ; lgY++ ){
            if( lgY > lgX +1 and lgX != 0 ) continue;
            if( !lgX and !lgY ){
                for( int i=0 ; i < n ; i++ ){
                    for( int j=0 ; j < m ; j++ ){
                        node[i][j][lgX][lgY] = i*m + j +1;
                    }
                }
                continue;
            }
            cerr << " - " << lgX << " " << lgY << endl;
            for( int i=0 ; i + pw[lgX] <= n ; i++ ){
                for( int j=0 ; j + pw[lgY] <= m ; j++ ){
                    cerr << " | " << i << " " << j << endl;
                    if( lgX == 0 and lgY == 1 ){
                        node[i][j][lgX][lgY] = ++num;
                        nas.push_back({{num, '+'}, {i*m+j+1, i*m+j+2}});
                    }else if( lgX == 1 and lgY == 0 ){
                        node[i][j][lgX][lgY] = ++num;
                        nas.push_back({{num, '+'}, {i*m+j+1, (i+1)*m+j+1}});
                    }else{
                        node[i][j][lgX][lgY] = ++num;
                        if( lgX ) nas.push_back({{num, '+'}, {node[i][j][lgX-1][lgY], node[i + pw[lgX-1]][j][lgX-1][lgY]}});
                        else nas.push_back({{num, '+'}, {node[i][j][lgX][lgY-1], node[i][j + pw[lgY-1]][lgX][lgY-1]}});
                    }

                    cerr << i << " " << j << " " << lgX << " " << lgY << " " << node[i][j][lgX][lgY] <<endl;
                }
            }
        }
    }

    cerr << "anansko" << endl;

    for( int i=0 ; i < n ; i++ ){
        for( int j=0 ; j < m ; j++ ){
            if( !i and !j ){
                reff[i][j] = 1;
                continue;
            }
            int x = 0;
            std::vector< int > add;
            cerr << i+1 << " " << j+1 << endl;
            for( int k = 0 ; k < MAX_LOG ; k++ ){
                if( (i+1) & ( 1 << k ) ){
                    cerr << " ! " << k << endl;
                    int y = 0;
                    for( int p = 0 ; p < MAX_LOG ; p++ ){
                        if( (j+1) & ( 1 << p ) ){
                            cerr << " # " << p << endl;
                            add.push_back( node[x][y][k][p] );
                            cerr << "add" << x << " " << y << " " << k << " " << p << " " << node[x][y][k][p] << endl;
                            y += pw[p];
                        }
                    }
                    x += pw[k];
                }
            }

            cerr << " add: " << endl;
            for( auto j : add ) cerr << j << " ";
            cerr << endl;

            if( add.size() == 1 ) reff[i][j] = add[0];
            else{
                nas.push_back({{++num, '+'}, {add[0], add[1]}});
                for( int k=2 ; k < add.size() ; k++ ){
                    nas.push_back({{num+1, '+'}, {num, add[k]}});
                    num++;
                }
                reff[i][j] = num;
            }
        }
    }

    if( num > 3e5 ) while( true );

    std::cout << num << endl;
    for( int i=0 ; i < n ; i++ ){
        for( int j=0 ; j < m ; j++ ){
            std::cout << reff[i][j] << " ";
        }
        std::cout << endl;
    }
    for( auto j : nas ){
        std::cout << j.first.first << " = " << j.second.first << " " << j.first.second << " " << j.second.second << endl;
        //std::cout << j.first.first << " = " << j.second.first << j.first.second << j.second.second << endl;
    }



    return 0;
}
