#include "gcdSquared.h"
#include<bits/stdc++.h>
using namespace std;

long long gcd(long long a, long long b) {
    if(b == 0) {
        return a;
    }
    return gcd(b, a%b);
}

vector<long long> haha(200001);
vector<long long> bruh(200001);
vector<long long> seg(200001);

void build(long long l, long long r, long long x) {
    if(l == r) {
        seg[x] = bruh[l];
        return;
    }
    long long m = (l+r)/2;
    build(l,m,x*2);
    build(m+1,r,x*2+1);
    seg[x] = gcd(seg[x*2],seg[x*2+1]);
}

long long calc(long long l, long long r, long long ql, long long qr, long long x) {
    if(ql == l && qr == r) {
        return seg[x];
    }
    long long m = (l+r)/2;
    if(qr <= m) {
        return calc(l,m,ql,qr,x*2);
    }
    else if(ql > m) {
        return calc(m+1,r,ql,qr,x*2+1);
    }
    else {
        return gcd(calc(l,m,ql,m,x*2),calc(m+1,r,m+1,qr,x*2+1));
    }
}

long long n;

void init(int N, const int v[]) {
    n = N;
    for(long long i = 1; i <= n; i++) {
        haha[i] = v[i];
    }
    for(long long i = 1; i < n; i++) {
        bruh[i] = haha[i+1]-haha[i];
    }
    build(1,n-1,1);
}

long long getGCD(int a, int b, int c, int l, int r) {
    if(l == r) {
        return haha[l];
    }
    else {
        long long d = calc(1,n-1,l,r-1,1);
        return gcd((long long)b*(long long)haha[l]+(long long)c,d*((long long)b));
    }
}
