/*
    Nevuzpitano ruso e cveta na kosite
    Silikon v ostata silikon v gurdite
    I parfuima natrapchiv i visoki botushi
    I cigari sled sexa tya obicha da pushi
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>

typedef long long llong;
const int MAXN = 200000 + 10;
const int INF  = 2e9;

int n, m, q;
std::vector <int> t[MAXN];
std::vector <int> dp[MAXN];

void solve()
{
    for (int query = 1 ; query <= q ; ++query)
    {
        int xs, ys, xt, yt;
        std::cin >> xs >> ys >> xt >> yt;
        for (int i = xt ; i >= xs ; --i)
        {
            for (int j = yt ; j >= ys ; --j)
            {
                dp[i][j] = INF;
                if (i == xt && j == yt) dp[i][j] = t[i][j];
                if (i < xt) dp[i][j] = std::min(dp[i][j], t[i][j] + dp[i + 1][j]);
                if (j < yt) dp[i][j] = std::min(dp[i][j], t[i][j] + dp[i][j + 1]);
            }
        }

        std::cout << dp[xs][ys] << '\n';
    }
}

void input()
{
    std::cin >> n >> m >> q;
    for (int i = 1 ; i <= n ; ++i)
    {
        t[i].resize(m + 1);
        dp[i].resize(m + 1);
        for (int j = 1 ; j <= m ; ++j)
        {
            std::cin >> t[i][j];
        }
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}