/*
    Nevuzpitano ruso e cveta na kosite
    Silikon v ostata silikon v gurdite
    I parfuima natrapchiv i visoki botushi
    I cigari sled sexa tya obicha da pushi
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>

typedef long long llong;
const int MAXN = 200000 + 10;
const int INF  = 2e9;

int n, m, q;
struct Query
{
    int xs, ys, xt, yt, idx;
    friend bool operator < (const Query &a, const Query &b)
    {
        if (a.xt != b.xt) return a.xt < b.xt;
        return a.yt < b.yt;
    }
};

int output[MAXN];
Query query[MAXN];
std::vector <int> t[MAXN];
std::vector <int> dp[MAXN];

void print()
{
    for (int i = 1 ; i <= q ; ++i)
    {
        std::cout << output[i] << '\n';
    }
}

void solve()
{
    int ptr = 1;
    std::sort(query + 1, query + 1 + q);
    for (int row = 1 ; row <= n ; ++row)
    {
        for (int col = 1 ; col <= m ; ++col)
        {
            if (ptr > q || query[ptr].xt != row || query[ptr].yt != col)
            {
                continue;
            }

            for (int i = row ; i >= 1 ; --i)
            {
                for (int j = col ; j >= 1 ; --j)
                {
                    dp[i][j] = INF;
                    if (i == row && j == col) dp[i][j] = t[i][j];
                    if (i < row) dp[i][j] = std::min(dp[i][j], t[i][j] + dp[i + 1][j]);
                    if (j < col) dp[i][j] = std::min(dp[i][j], t[i][j] + dp[i][j + 1]);
                }
            }

            while (ptr <= q && query[ptr].xt == row && query[ptr].yt == col)
            {
                output[query[ptr].idx] = dp[query[ptr].xs][query[ptr].ys];
                ptr++;
            }
        }
    }
}

void input()
{
    std::cin >> n >> m >> q;
    for (int i = 1 ; i <= n ; ++i)
    {
        t[i].resize(m + 1);
        dp[i].resize(m + 1);
        for (int j = 1 ; j <= m ; ++j)
        {
            std::cin >> t[i][j];
        }
    }

    for (int i = 1 ; i <= q ; ++i)
    {
        std::cin >> query[i].xs >> query[i].ys >> query[i].xt >> query[i].yt;
        query[i].idx = i;
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();
    print();

    return 0;
}