/*
    Nevuzpitano ruso e cveta na kosite
    Silikon v ostata silikon v gurdite
    I parfuima natrapchiv i visoki botushi
    I cigari sled sexa tya obicha da pushi
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <random>
#include <vector>

typedef long long llong;
const int MAXN = 200000 + 10;
const int MAXQ = 200000 + 10;
const int PEOPLE_SIZE = 600;
const int INF  = 2e9;

int n, m, q;
struct Query
{
    int xs, ys, xt, yt, idx;
    friend bool operator < (const Query &a, const Query &b)
    {
        if (a.xt != b.xt) return a.xt < b.xt;
        return a.yt < b.yt;
    }
};

std::vector <int> t[MAXN];
std::vector <int> dp[PEOPLE_SIZE][6];
std::mt19937 rng(69420);
int chosenRow[PEOPLE_SIZE];
int chosenCol[PEOPLE_SIZE];

void print()
{
    for (int i = 1 ; i <= q ; ++i)
    {
        std::cout << output[i] << '\n';
    }
}

void solve()
{
    for (int p = 0 ; p < PEOPLE_SIZE ; ++p)
    {
        chosenRow[p] = rng() % n + 1;
        chosenCol[p] = rng() % m + 1;
        if (p == 0)
        {
            chosenRow[p] = n;
            chosenCol[p] = m;
        }

        // std::cout << "choose: " << chosenRow[p] << ' ' << chosenCol[p] << '\n';
        for (int i = chosenRow[p] ; i >= 1 ; --i)
        {
            for (int j = chosenCol[p] ; j >= 1 ; --j)
            {
                dp[p][i][j] = INF;
                if (i == chosenRow[p] && j == chosenCol[p]) dp[p][i][j] = t[i][j];
                if (i < chosenRow[p]) dp[p][i][j] = std::min(dp[p][i][j], t[i][j] + dp[p][i + 1][j]);
                if (j < chosenCol[p]) dp[p][i][j] = std::min(dp[p][i][j], t[i][j] + dp[p][i][j + 1]);
            }
        }
    }   

    for (int i = 1 ; i <= q ; ++i)
    {
        int xs, ys, xt, yt;
        std::cin >> xs >> ys >> xt >> yt;
        int ans = -INF;

        for (int p = 0 ; p < PEOPLE_SIZE ; ++p)
        {
            if (xt <= chosenRow[p] && yt <= chosenCol[p])
            {
                ans = std::max(ans, dp[p][xs][ys] - dp[p][xt][yt] + t[xt][yt]);
            }
        }

        std::cout << ans << '\n';
    }
}

void input()
{
    std::cin >> n >> m >> q;
    for (int i = 1 ; i <= n ; ++i)
    {
        t[i].resize(m + 1);
        for (int j = 0 ; j < PEOPLE_SIZE ; ++j) dp[j][i].resize(m + 1);
        for (int j = 1 ; j <= m ; ++j)
        {
            std::cin >> t[i][j];
        }
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();
    // print();

    return 0;
}