/*
    Nevuzpitano ruso e cveta na kosite
    Silikon v ostata silikon v gurdite
    I parfuima natrapchiv i visoki botushi
    I cigari sled sexa tya obicha da pushi
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>

typedef long long llong;
const int MAX_NODES = 3e5;
const int MAXN = 64 + 10;
const int INF  = 1e9;

int n, m;
struct Node
{
    char type;
    int l, r;
};

int ptr;
Node nodes[MAX_NODES];
int answer[MAXN][MAXN];
int rowPrefixes[MAXN][MAXN];

std::vector <int> makePrefix(std::vector <int> &values)
{
    if (values.size() == 1)
    {
        return values;
    }

    int mid = values.size() / 2;
    std::vector <int> left, right;
    for (int i = 0 ; i < mid ; ++i)
    {
        left.push_back(values[i]);
    }

    for (int i = mid ; i < values.size() ; ++i)
    {
        right.push_back(values[i]);
    }

    std::vector <int> ansLeft = makePrefix(left);
    std::vector <int> ansRight = makePrefix(right);
    std::vector <int> ans;

    for (const int &idx : ansLeft) ans.push_back(idx);
    for (int i = 0 ; i < ansRight.size() ; ++i)
    {
        ptr++;
        nodes[ptr] = {'+', ansLeft.back(), ansRight[i]};
        // std::cout << "make node: " << ptr << " = " << ansLeft.back() << ' ' << ansRight[i] << '\n';    
        ans.push_back(ptr);
    }

    // std::cout << "make prefixes\n";
    // for (const int &val : values) std::cout << val << ' '; std::cout << '\n';
    // std::cout << "are\n";
    // for (const int &val : ans) std::cout << val << ' '; std::cout << '\n';
    return ans;
}

void print()
{
    std::cout << ptr << '\n';
    for (int i = 1 ; i <= n ; ++i)
    {
        for (int j = 1 ; j <= m ; ++j)
        {
            std::cout << answer[i][j] << ' ';
        }

        std::cout << '\n';
    }

    for (int i = n * m + 1 ; i <= ptr ; ++i)
    {
        std::cout << i << " = " << nodes[i].l << ' ' << nodes[i].type << ' ' << nodes[i].r << '\n';
    }
}

void solve()
{
    ptr = n * m;
    for (int i = 1 ; i <= n ; ++i)
    {
        for (int j = 1 ; j <= m ; ++j)
        {
            nodes[(i - 1) * m + j] = {'?', -1, -1};
        }
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        std::vector <int> row;
        for (int j = 1 ; j <= m ; ++j)
        {
            row.push_back((i - 1) * m + j);
        }

        std::vector <int> prefixes = makePrefix(row);
        for (int j = 1 ; j <= m ; ++j)
        {
            rowPrefixes[i][j] = prefixes[j - 1];
        }
    }

    for (int j = 1 ; j <= m ; ++j)
    {
        std::vector <int> row;
        for (int i = 1 ; i <= n ; ++i)
        {
            row.push_back(rowPrefixes[i][j]);
        }

        std::vector <int> prefixes = makePrefix(row);
        for (int i = 1 ; i <= n ; ++i)
        {
            answer[i][j] = prefixes[i - 1];
        }
    }
}

void input()
{
    std::cin >> n >> m;
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();
    print();

    return 0;
}