#include "gcdSquared.h"
#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>

typedef long long llong;
const int MAXN = 200000 + 10;
const int INF  = 1e9;

int n;
llong v[MAXN];

void init(int _n, const int _v[])
{
    n = _n;
    for (int i = 1 ; i <= n ; ++i)
    {
        v[i] = _v[i];
    }
}

llong getGCD(int a, int b, int c, int l, int r)
{
    llong res1 = 0;
    llong res2 = 0;
    for (int i = l + 1 ; i <= r ; ++i)
    {
        res1 = std::__gcd(res1, a * v[i] * v[i] + b * v[i]);
        // res2 = std::__gcd(res2, );
    }

    // res1 *= res2;
    res1 = std::__gcd(res1, a * v[l] * v[l] + b * v[l] + c);
    return res1;
}