#include<bits/stdc++.h>

#define PLUS 0
#define MINUS 1
#define MAXN 65

using namespace std;

int n, m, ind, ans[MAXN][MAXN], initInd;
struct Node
{
    int l, r;
    bool t;
    int indx;
};
vector<Node> nodes;
struct Hash
{
    long long operator()(pair<int, int> p) const
    {
        return (p.first + p.second + 1) * (p.first - 1);
    }
};
unordered_map<pair<int, int>, int, Hash> mp;

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n>>m;
}
void solve()
{
    for(int i = 0; i < n; i ++)
    {
        if(m > 1)
        {
            Node entry = {i * m + 1, i * m + 2, PLUS, nodes.size() + 1};
            nodes.push_back(entry);
            mp[{i * m + 1, i * m + 2}] = nodes.size() + initInd;
        }
        for(int j = 2; j < m; j ++)
        {
            Node cur = {nodes.size() + initInd, i * m + j + 1, PLUS, nodes.size() + 1};
            nodes.push_back(cur);
            mp[{i * m + 1, i * m + j + 1}] = nodes.size() + initInd;
            //ans[i][j] = nodes.size() + initInd;
        }
    }
    ans[0][0] = 1;
    for(int j = 1; j < m; j ++)
    {
        ans[0][j] = mp[{1, j + 1}];
    }
    for(int i = 1; i < n; i ++)
    {
        for(int j = 1; j < m; j ++)
        {
            Node cur = {mp[{1, (i - 1) * m + j + 1}], mp[{i * m + 1, i * m + j + 1}], PLUS, nodes.size() + 1};
            //cout<<i * m + 1<<" "<<i * m + j + 1<<": "<<mp[{i * m + 1, i * m + j + 1}]<<endl;
            nodes.push_back(cur);
            mp[{1, i * m + j + 1}] = initInd + nodes.size();
            ans[i][j] = initInd + nodes.size();
        }
    }
    if(n > 1)
    {
        Node entry = {1, m + 1, PLUS, nodes.size() + 1};
        nodes.push_back(entry);
        mp[{1, m + 1}] = initInd + nodes.size();
        ans[1][0] = initInd + nodes.size();
    }
    for(int i = 2; i < n; i ++)
    {
        Node entry = {mp[{1, (i - 1) * m + 1}], i * m + 1, PLUS, nodes.size() + 1};
        nodes.push_back(entry);
        mp[{1, i * m + 1}] = initInd + nodes.size();
        ans[i][0] = initInd + nodes.size();
    }
}
int main()
{
    read();
    initInd = n * m;
    solve();
    for(int i = 0; i < n; i ++)
    {
        for(int j = 0; j < m; j ++)
        {
            cout<<ans[i][j]<<' ';
        }
        cout<<endl;
    }
    for(int i = 0; i < nodes.size(); i ++)
    {
        cout<<nodes[i].indx + initInd<<" = "<<nodes[i].l<<" + "<<nodes[i].r<<endl;
    }
    return 0;
}

