#include "gcdSquared.h"
#include <iostream>
#include <algorithm>
#include <cmath>
using namespace std;
const int MAXN=2e5+10;
int n;
long long arr[MAXN];
int tree[4*MAXN];
void build_tree(int node, int l, int r) {
    if (l==r) {
        tree[node]=arr[l];
        return;
    }
    int mid=(l+r)/2;
    build_tree(node*2,l,mid);
    build_tree(node*2+1,mid+1,r);
    tree[node]=__gcd(tree[node*2],tree[node*2+1]);
}
void init(int N, const int v[]) {
    n=N;
    for (int i=1;i<=n;i++) arr[i]=v[i];
    build_tree(1,1,n);
}
long long getGCD(int A, int B, int C, int l, int r) {
    long long res, cur;
    long long a=A, b=B, c=C;
    for (long long i=l;i<=r;i++) {
        cur=a*arr[i]*arr[i]+b*arr[i]+c;
        if (i==l) res=cur;
        else res=__gcd(res,cur);
    }
    return res;
}
