#include "gcdSquared.h"
#include <iostream>
#include <algorithm>
#include <cmath>
using namespace std;
const int MAXN=2e5+10;
int n;
long long arr[MAXN];
int sp[MAXN][20], stepen[MAXN];
int query(int l, int r) {
    int st=stepen[r-l+1];
    return __gcd(sp[l][st],sp[r-(1<<st)+1][st]);
}
void init(int N, const int v[]) {
    n=N;
    for (int i=1;i<=n;i++) arr[i]=sp[i][0]=v[i];
    for (int i=1;(1<<i)<=n;i++) {
        for (int j=1;j+(1<<i)-1<=n;j++) {
            sp[j][i]=__gcd(sp[j][i-1],sp[j+(1<<(i-1))][i-1]);
        }
    }
    int st=0;
    for (int i=1;i<=n;i++) {
        if ((1<<(st+1))<i) st++;
        stepen[i]=st;
    }
}
long long NOK(long long a, long long b) {
    return (a/__gcd(a,b))*b;
}
long long getGCD(int A, int B, int C, int l, int r) {
    long long res, cur;
    long long a=A, b=B, c=C;
    if (a==0) {
        if (c==0) {
            return b*query(l,r);
        }
        if (b==0) {
            cur=query(l,r);
            return __gcd(c,cur);
        }
        cur=__gcd(b,c);
        res=__gcd((long long)query(l,r),c/cur);
        //cout << cur << ' ' << res << ' ' << c/cur << endl;
        return res*cur;
    }
    for (long long i=l;i<=r;i++) {
        cur=a*arr[i]*arr[i]+b*arr[i]+c;
        if (i==l) res=cur;
        else res=__gcd(res,cur);
    }
    return res;
}
