#include <bits/stdc++.h>
using namespace std;

const int maxn = 1e4+2, inf = 1e9;
struct edge
{
    int ver, p;
    bool operator<(const edge&e)const
    {
        return(p > e.p);
    }
};
vector <edge> v[maxn];
int n, m, q, a[maxn][maxn], d[maxn][maxn];
bool used[maxn], h[maxn];

void dijkstra(int ver)
{
    for (int l=1; l<n*m; ++l)
        d[ver][l] = inf;
    h[ver] = true;
    memset(used, 0, sizeof(used));
    d[ver][ver] = 0;
    //used[ver] = true;
    edge e = {ver, 0}, nb;
    priority_queue <edge> q;
    q.push(e);
    int i, len;

    while (!q.empty())
    {
        e = q.top(); q.pop();
        if (!used[e.ver])
        {
                used[e.ver] = true;
                len = (int)(v[e.ver].size());
                for (i=0; i<len; ++i)
                {
                    nb = v[e.ver][i];
                    if (d[ver][nb.ver] > d[ver][e.ver] + nb.p)
                    {
                        nb.p += d[ver][e.ver];
                        d[ver][nb.ver] = nb.p;
                        q.push(nb);
                    }
                }
        }
    }
}

void solve()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> m >> q ;
    int i, j, k1, k2;
    for (i=1; i<=n; ++i)
    {
        for (j=1; j<=m; ++j)
        {
            cin >> a[i][j] ;
            if (i == 1 && j == 1) continue;
            if (i == 1)
            {
                k1 = (i-1)*m+j;
                k2 = (i-1)*m+j-1;
                v[k2].push_back({k1, a[i][j]});
            }
            else if (j == 1)
            {
                k1 = (i-1)*m+j;
                k2 = (i-2)*m+j;
                v[k2].push_back({k1, a[i][j]});
            }
            else
            {
                k1 = (i-1)*m+j;
                k2 = (i-1)*m+j-1;
                v[k2].push_back({k1, a[i][j]});

                k1 = (i-1)*m+j;
                k2 = (i-2)*m+j;
                v[k2].push_back({k1, a[i][j]});
            }
        }
    }

    int x1, y1, x2, y2;
    for (i=1; i<=q; ++i)
    {
        cin >> x1 >> y1 >> x2 >> y2 ;
        k1 = (x1-1)*m+y1;
        if (!h[k1])
            dijkstra(k1);
        k2 = (x2-1)*m+y2;
        cout << d[k1][k2] << '\n' ;
    }
}

int main()
{
    solve();
    return 0;
}