#include <bits/stdc++.h>
using namespace std;

const int maxn = 65;
int n, m, len, a[maxn][maxn];
map < set<int> , int> mymap;
vector <pair<int, int>> p;

void make_sum(int x, int y)
{
    if (x == 1 && y == 1)
    {
        a[x][y] = 1;
        return;
    }

    int i, j;
    if (x == 1)
    {
        set <int> s;
        for (i=1; i<y; ++i)
            s.insert(i);

        p.push_back({mymap[s], y});
        s.insert(y);
        mymap[s] = (++len);
        a[x][y] = len;
        return;
    }

    if (y == 1)
    {
        set <int> s;
        for (i=1; i<x; ++i)
            s.insert((i-1)*m + 1);

        p.push_back({mymap[s], (x-1)*m+1});
        s.insert((x-1)*m+1);
        mymap[s] = (++len);
        a[x][y] = len;
        return;
    }

    set <int> s1, s2;
    for (i=1; i<x; ++i)
        s1.insert((i-1)*m+y);

    p.push_back({mymap[s1], (x-1)*m+y});
    s1.insert((x-1)*m+y);
    mymap[s1] = (++len);

    for (i=1; i<=x; ++i)
    {
        for (j=1; j<y; ++j)
        {
            s2.insert((i-1)*m+j);
        }
    }
    p.push_back({mymap[s2], mymap[s1]});
    for (i=1; i<=x; ++i)
        s2.insert((i-1)*m+y);
    mymap[s2] = (++len);
    a[x][y] = len;
}

void init()
{
    int i;
    for (i=1; i<=n*m; ++i)
    {
        set<int> s;
        s.insert(i);
        mymap[s] = i;
    }
}

void solve()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> m ;
    len = n * m ;
    init();
    /// p[0] - pair n*m+1

    int i, j;
    for (i=1; i<=n; ++i)
    {
        for (j=1; j<=m; ++j)
        {
            make_sum(i,j);
        }
    }
}

void print()
{
    cout << len << '\n' ;
    int i, j;
    for (i=1; i<=n; ++i)
    {
        for (j=1; j<=m; ++j)
        {
            cout << a[i][j] << " " ;
        }
        cout << '\n' ;
    }

    for (i=0; i<len-n*m; ++i)
    {
        cout << i + n*m + 1 << " = " << p[i].first << " + " << p[i].second << '\n' ;
    }
}

int main()
{
    solve();
    print();
    return 0;
}