#include <bits/stdc++.h>
using namespace std;

const short int maxn = 65;
short int n, m, len, a[maxn][maxn];
string num[maxn*maxn], sets[maxn][maxn], columns[maxn][maxn];
map < string , short int> mymap;
vector <pair <short int, short int> > p;

void make_sum(short int x, short int y)
{
    if (x == 1 && y == 1)
    {
        a[x][y] = 1;
        return;
    }

    short int i, j;
    if (x == 1)
    {
        p.push_back({mymap[sets[x][y-1]], y});
        mymap[sets[x][y]] = (++len);
        a[x][y] = len;
        return;
    }

    if (y == 1)
    {
        p.push_back({mymap[sets[x-1][y]], (x-1)*m+1});
        mymap[sets[x][y]] = (++len);
        a[x][y] = len;
        return;
    }

    p.push_back({mymap[columns[y][x-1]], (x-1)*m+y});
    mymap[columns[y][x]] = (++len);

    p.push_back({mymap[sets[x][y-1]], mymap[columns[y][x]]});
    mymap[sets[x][y]] = (++len);
    a[x][y] = len;
}

string to_string(short int number)
{
    string res = "";
    char c;
    short int k;
    while (number != 0)
    {
        k = number % 10;
        c = (char)(k+'0');
        res = "#" + res;
        res[0] = c;
        number /= 10;
    }
    return res;
}

void init()
{
    short int i;
    for (i=1; i<=n*m; ++i)
    {
        num[i] = to_string(i);
        mymap[num[i]] = i;
        //cout << i << " " << num[i] << '\n' ;
    }

    short int j, k;
    for (i=1; i<=n; ++i)
    {
        for (j=1; j<=m; ++j)
        {
            if (i == 1)
            {
                sets[i][j] = "";
                for (k=1; k<=j; ++k)
                {
                    //sets[i][j].insert((i-1)*m+k);
                    sets[i][j] += num[(i-1)*m+k];
                }
            }
            else
            {
                //sets[i][j] = sets[i-1][j];
                sets[i][j] = sets[i-1][j];
                for (k=1; k<=j; ++k)
                {
                    //sets[i][j].insert((i-1)*m+k);
                    sets[i][j] += num[(i-1)*m+k];
                }
            }
        }
    }

    string h;
    for (j=1; j<=m; ++j)
    {
        h = "";
        for (i=1; i<=n; ++i)
        {
            h += num[(i-1)*m+j];
            columns[j][i] = h;
        }
    }
}

void solve()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> m ;
    len = n * m ;
    init();

    short int i, j;
    for (i=1; i<=n; ++i)
    {
        for (j=1; j<=m; ++j)
        {
            make_sum(i,j);
        }
    }
}

void print()
{
    cout << len << '\n' ;
    short int i, j;
    for (i=1; i<=n; ++i)
    {
        for (j=1; j<=m; ++j)
        {
            cout << a[i][j] << " " ;
        }
        cout << '\n' ;
    }

    for (i=0; i<len-n*m; ++i)
    {
        cout << i + n*m + 1 << " = " << p[i].first << " + " << p[i].second << '\n' ;
    }
}

int main()
{
    solve();
    print();
    return 0;
}