#include "gcdSquared.h"
#include<bits/stdc++.h>

using namespace std;

int N;
int V[200006];
int tree[800006];

long long absol(long long t)
{
    if(t<0) return -t;
    return t;
}

long long my_gcd(long long a, long long b)
{
    if(a==0) return b;
    if(b==0) return a;
    return __gcd(a, b);
}

void build_tree(int v, int le, int ri)
{
    if(le==ri) tree[v]=absol(V[le]-V[le+1]);
    else
    {
        int mid=(le+ri)/2;
        build_tree(2*v, le, mid);
        build_tree(2*v+1, mid+1, ri);
        tree[v]=my_gcd(tree[2*v], tree[2*v+1]);
    }
}

int query(int v, int le, int ri, int be, int en)
{
    if(le>en || ri<be) return 0;
    if(be<=le && ri<=en) return tree[v];
    int mid=(le+ri)/2;
    return my_gcd(query(2*v, le, mid, be, en), query(2*v+1, mid+1, ri, be, en));
}

void init(int n, const int v[])
{
    N=n;
    for(int i=N; i>=1; i--) V[i]=v[i];
    build_tree(1, 1, N-1);
}

long long getGCD(int a, int b, int c, int l, int r)
{
    if(b==0) return c;
    if(r==l) return (long long)b*V[l]+c;
    return my_gcd((long long)b*V[l]+c, (long long)b*query(1, 1, N-1, l, r-1));
}
