#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}


const int maxq = 2e5 + 10;
const int maxn = 2e5 + 10;
struct query
{
    int xs, ys, xt, yt;
    int idx;
    query(int _xs = 0, int _ys = 0, int _xt = 0, int _yt = 0, int _idx = 0)
    {
        xs = _xs;
        ys = _ys;
        xt = _xt;
        yt = _yt;
        idx = _idx;
    }

    void input()
    {
        cin >> xs >> ys >> xt >> yt;
    }
}task[maxq];


int n, m, q;
vector < vector < int > > a;
const int smalln = 1e4 + 10;


int prec[smalln][smalln];

void input()
{
    cin >> n >> m >> q;
    a.resize(n + 1);
    a[0].resize(m + 1);
    for (int i = 1; i <= n; i ++)
    {
        a[i].resize(m + 1);
        for (int j = 1; j <= m; j ++)
        {
            cin >> a[i][j];
        }
    }

    for (int i = 1; i <= q; i ++)
    {
        task[i].input();
        task[i].idx = i;
    }
}

const int inf = 2e9;
vector < vector < int > > dp;

int cell_number(int x, int y)
{
    return (x - 1) * m + y;
}

const int maxblock = 6;
struct node
{
    int v[maxblock][maxblock];

    void clean()
    {
        for (int i = 1; i <= n; i ++)
            for (int j = 1; j <= n; j ++)
            v[i][j] = inf;
    }
};

node tree[4 * maxn];
node merge_node(node lf, node rf)
{
    node res;
    res.clean();
    for (int i = 1; i <= n; i ++)
        for (int j = i; j <= n; j ++)
        for (int k = i; k <= j; k ++)
        {
            if (lf.v[i][k] + rf.v[k][j] < res.v[i][j])
                res.v[i][j] = lf.v[i][k] + rf.v[k][j];
        }

    return res;
}

void build(int root, int left, int right)
{
    if (left == right)
    {
        tree[root].clean();
        for (int i = 1; i <= n; i ++)
        {
            int sum = 0;
            for (int j = i; j <= n; j ++)
            {
                sum += a[j][left];
                tree[root].v[i][j] = sum;
            }
        }
        return;
    }

    int mid = (left + right) / 2;
    build(root * 2, left, mid);
    build(root * 2 + 1, mid + 1, right);

    tree[root] = merge_node(tree[root * 2] ,tree[root * 2 + 1]);
    /**cout << "state " << left << " " << right << endl;
    for (int i = 1; i <= n; i ++, cout << endl)
        for (int j = i; j <= n; j ++)
        cout << tree[root].v[i][j] << " ";*/
}

node query(int root, int left, int right, int qleft, int qright)
{
    if (left == qleft && right == qright)
        return tree[root];

    int mid = (left + right) / 2;
    if (qright <= mid)
        return query(root * 2, left, mid, qleft, qright);
    if (qleft > mid)
        return query(root * 2 + 1, mid + 1, right, qleft, qright);

    return merge_node(query(root * 2, left, mid, qleft, mid),
                      query(root * 2 + 1, mid + 1, right, mid + 1, qright));
}

void answer_queries()
{
    for (int i = 1; i <= q; i ++)
    {
        node cur = query(1, 1, m, task[i].ys, task[i].yt);
        cout << cur.v[task[i].xs][task[i].xt] << endl;
    }
}
void solve()
{
    input();
    ///precompute();
    build(1, 1, m);
    answer_queries();

}

int main()
{
    speed();
    solve();
    return 0;
}
