#include<bits/stdc++.h>
#include "gcdSquared.h"
#define endl "\n"
using namespace std;
long long N;
long long A[200010];
long long sp[200010][20];
long long GCD(long long X,long long Y){
    if(X==0 || Y==0) return max(X,Y);
    return __gcd(X,Y);
}
void sparseTable(){
    for(long long i=0;i<N-1;i++){
        sp[i][0]=abs(A[i]-A[i+1]);
        //cout<<sp[i][0]<<" ";
    }
    //cout<<endl;
    for(long long i=1;(1<<i)-1<N-1;i++){
        for(long long j=0;j+(1<<i)-1<N-1;j++){
            sp[j][i]=GCD(sp[j][i-1],sp[j+(1<<(i-1))][i-1]);
            //cout<<sp[j][i]<<" ";
        }
        //cout<<endl;
    }
}
void init(long long n, const long long v[]){
    N=n;
    for(long long i=0;i<N;i++){
        A[i]=v[i];
    }
    sparseTable();
}
long long getGCD(long long a, long long b, long long c, long long l, long long r){
    l--;
    r--;
    if(l==r) return A[l];
    long long LOG=(long long)floor(log2(r-l));
    return GCD(GCD(sp[l][LOG],sp[r-(1<<LOG)][LOG]),a*A[l]*A[l]+b*A[l]+c);
}
/*int main(){
    long long xx[9]={4,4,4,8,10,7,4,10,5};
    init(9,xx);
    cout<<getGCD(0,7,13,1,4)<<endl;
    cout<<getGCD(0,8,13,5,7)<<endl;
    cout<<getGCD(0,7,13,8,9)<<endl;
    cout<<getGCD(0,7,13,2,5)<<endl;
    return 0;
}*/
