#include<bits/stdc++.h>
#include "gcdSquared.h"
#define endl "\n"
using namespace std;
long long N;
long long A[200010];
long long sp[200010][20];
long long GCD(long long X,long long Y){
    if(X==0 || Y==0) return max(X,Y);
    return __gcd(X,Y);
}
void sparseTable(){
    for(long long i=0;i<N-1;i++){
        if(A[i]>A[i+1]) sp[i][0]=A[i]-A[i+1];
        else sp[i][0]=A[i+1]-A[i];
        //cout<<sp[i][0]<<" ";
    }
    //cout<<endl;
    for(long long i=1;(1<<i)-1<N-1;i++){
        for(long long j=0;j+(1<<i)-1<N-1;j++){
            sp[j][i]=GCD(sp[j][i-1],sp[j+(1<<(i-1))][i-1]);
            //cout<<sp[j][i]<<" ";
        }
        //cout<<endl;
    }
}
void init(int n, const int v[]){
    N=n;
    for(long long i=0;i<N;i++){
        A[i]=v[i+1];
    }
    sparseTable();
}
long long getGCD(int a, int b, int c, int l, int r){
    if(a==0 && b==0) return c;
    l--;
    r--;
    if(l==r) return b*A[l]+c;
    long long LOG=(long long)floor(log2(r-l));
    long long g=GCD(b,c);
    return g*GCD(GCD(sp[l][LOG],sp[r-(1<<LOG)][LOG]),b/g*A[l]+c/g);
}
/*int main(){
    int xx[6]={0,3,5,9,17,33};
    init(5,xx);
    cout<<getGCD(0,3,1,1,1)<<endl;
    cout<<getGCD(0,3,1,1,2)<<endl;
    cout<<getGCD(0,3,1,1,3)<<endl;
    cout<<getGCD(0,3,1,1,4)<<endl;
    cout<<getGCD(0,3,1,1,5)<<endl;
    cout<<getGCD(0,3,1,2,2)<<endl;
    cout<<getGCD(0,3,1,2,3)<<endl;
    cout<<getGCD(0,3,1,2,4)<<endl;
    cout<<getGCD(0,3,1,2,5)<<endl;
    cout<<getGCD(0,3,1,3,3)<<endl;
    cout<<getGCD(0,3,1,3,4)<<endl;
    cout<<getGCD(0,3,1,3,5)<<endl;
    cout<<getGCD(0,3,1,4,4)<<endl;
    cout<<getGCD(0,3,1,4,5)<<endl;
    cout<<getGCD(0,3,1,5,5)<<endl;
    return 0;
}*/
