#include <iostream>
#include <vector>
using namespace std;
const int MAXN = 64 + 1;
const int INF = 1e9 + 7;
int table[MAXN][MAXN];
void solve() {
    int n, m;
    cin >> m >> n;
    vector< pair<int, int> > ans;
    int cnt = n * m + 1;
    table[1][1] = 1;
    for (int y = 1; y <= m; y++) {
        for (int x = 2; x <= n; x++) {
            if (x == 2) {
                ans.push_back({1 + (y - 1) * n, 2 + (y - 1) * n});
                cnt++;
            } else {
                ans.push_back({cnt - 1, x + (y - 1) * n});
                cnt++;
            }
            if (y == 1) {
                table[x][1] = cnt - 1;
            }
        }
    }
    for (int y = 2; y <= m; y++) {
        for (int x = 1; x <= n; x++) {
            if (y == 2) {
                if (x == 1) {
                    ans.push_back({1, 1 + n});
                } else {
                    ans.push_back({n * m + x - 1, n * m + x - 2 + n});
                }
                cnt++;
            } else {
                if (x == 1) {
                    ans.push_back({cnt - n, x + (y - 1) * n});
                } else {
                    ans.push_back({cnt - n, m * n + x + (y - 1) * n - 2 * n});
                }
                cnt++;
            }
            if (y > 1) {
                table[x][y] = cnt - 1;
            }
        }
    }
    cout << cnt - 1 << '\n';
    for (int y = 1; y <= m; y++) {
        for (int x = 1; x <= n; x++) {
            cout << table[x][y] << ' ';
        }
        cout << '\n';
    }
    for (int i = 0; i < ans.size(); i++) {
        cout << n * m + i + 1 << " = " << ans[i].first << " + " << ans[i].second << '\n';
    }
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}
