#include <iostream>
#include <vector>
//#include "gcdSquared.h"
const int MAXN = 2 * 1e5 + 1;
long long arr[MAXN];
long long diff[MAXN];
long long sparse[MAXN][20];
long long logg[MAXN];
struct Delitel{
    long long d;
    long long r[2];
};
std::vector<Delitel> poss;
long long asb(long long a) {
    if (a < 0) {
        return -a;
    } else {
        return a;
    }
}
long long nod(long long a, long long b) {
    if (a < b) {
        std::swap(a, b);
    }
    if (b == 0) {
        return a;
    }
    return nod(b, a % b);
}
long long nok(long long a, long long b) {
    return a * b / nod(a, b);
}
void check(const int div, int n) {
    int res[2];
    res[0] = arr[1] % div;
    res[1] = -1;
    for (int i = 2; i <= n; i++) {
        if (arr[i] % div != res[0]) {
            if (res[1] == -1) {
                res[1] = arr[i] % div;
            } else if (arr[i] % div != res[1]) {
                return;
            }
        }
    }
    Delitel tool;
    tool.d = div;
    tool.r[0] = res[0];
    tool.r[1] = res[1];
    poss.push_back(tool);
}
//void init(int n, const int v[]) {
//    for (int i = 1; i <= n; i++) {
//        arr[i] = v[i];
//    }
////    logg[1] = 0;
////    for (int i = 2; i <= n; i++) {
////        logg[i] = logg[i - 1];
////        if ((1 << (logg[i] + 1)) == i) {
////            logg[i]++;
////        }
////    }
////    for (int i = 1; i < n; i++) {
////        sparse[i][0] = asb(arr[i + 1] - arr[i]);
////    }
////    for (int j = 1; (1 << j) <= n - 1; j++) {
////        for (int i = 1; i <= n - 1; i++) {
////            sparse[i][j] = nod(sparse[i][j - 1], sparse[std::min(i + (1 << (j - 1)), n - 1)][j - 1]);
////        }
////    }
//    int x = asb(arr[1] - arr[2]);
//    for (int i = 2; i * i <= x; i++) {
//        if (x % i == 0) {
//            check(i, n);
//            if (i * i != x) {
//                check(x / i, n);
//            }
//        }
//    }
//    x = asb(arr[1] - arr[3]);
//    for (int i = 2; i * i <= x; i++) {
//        if (x % i == 0) {
//            check(i, n);
//            if (i * i != x) {
//                check(x / i, n);
//            }
//        }
//    }
//    x = asb(arr[2] - arr[3]);
//    for (int i = 2; i * i <= x; i++) {
//        if (x % i == 0) {
//            check(i, n);
//            if (i * i != x) {
//                check(x / i, n);
//            }
//        }
//    }
//}


//long long getGCD(int a, int b, int c, int l, int r) {
//    if (l == r) {
//        return a * arr[l] * arr[l] + b * arr[l] + c;
//    }
//    r--;
//    int lg = logg[r - l + 1];
//    long long curr = nod(sparse[l][lg], sparse[r - (1 << lg) + 1][lg]);
//    long long bas = nod(a, nod(b, c));
//    a /= bas;
//    b /= bas;
//    c /= bas;
//    return bas * nod(curr, a * arr[l] * arr[l] + b * arr[l] + c);
//}
long long getGCD(int a, int b, int c, int l, int r) {
    long long bas = nod(a, nod(b, c));
    a /= bas;
    b /= bas;
    c /= bas;
    long long ans = 1;
    for (auto it : poss) {
        if (it.r[1] == -1 ||
            (((a * it.r[0] * it.r[0] + b * it.r[0] + c) % it.d == 0) &&
             ((a * it.r[1] * it.r[1] + b * it.r[1] + c) % it.d == 0))) {
            ans = nok(ans, it.d);
        }
    }
    return ans * bas;
}


int main() {
    int n;
    std::cin >> n;
    for (int i = 1; i <= n; i++) {
        std::cin >> arr[i];
    }
    int x = asb(arr[1] - arr[2]);
    for (int i = 2; i * i <= x; i++) {
        if (x % i == 0) {
            check(i, n);
            if (i * i != x) {
                check(x / i, n);
            }
        }
    }
    check(x, n);
    x = asb(arr[1] - arr[3]);
    for (int i = 2; i * i <= x; i++) {
        if (x % i == 0) {
            check(i, n);
            if (i * i != x) {
                check(x / i, n);
            }
        }
    }
    check(x, n);
    x = asb(arr[2] - arr[3]);
    for (int i = 2; i * i <= x; i++) {
        if (x % i == 0) {
            check(i, n);
            if (i * i != x) {
                check(x / i, n);
            }
        }
    }
    check(x, n);
    int q;
    std::cin >> q;
    while (q --> 0) {
        int a, b, c, l, r;
        std::cin >> a >> b >> c >> l >> r;
        std::cout << getGCD(a, b, c, l, r) << '\n';
    }
}
