#include <iostream>
#include <cmath>
using namespace std;



int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);


    int n, m;
    cin >> n >> m;
    int q;
    cin  >> q;
    long long table[n+1][m+1];
    long long prefix[n+1][m+1];

    for(int i=1; i<=n; i++)
    {
        for(int j=1; j<=m; j++)
        {
            cin >> table[i][j];
        }
    }


    prefix[1][1]=table[1][1];
    for(int j=2; j<=m; j++)
    {
        prefix[1][j]=table[1][j]+prefix[1][j-1];
    }
    for(int i=1; i<=n; i++)
    {
        prefix[i][1]=table[i][1]+prefix[i-1][1];
    }

    for(int i=2; i<=n; i++)
    {
        for(int j=2; j<=m; j++)
        {
            prefix[i][j]=min(prefix[i-1][j], prefix[i][j-1])+table[i][j];
        }
    }
    /*for(int i=1; i<=n; i++)
    {
        for(int j=1; j<=m; j++)
        {
            cout << table[i][j] << " ";
        }
        cout << endl;
    }*/

    /*for(int i=1; i<=n; i++)
    {
        for(int j=1; j<=m; j++)
        {
            cout << prefix[i][j] << " ";
        }
        cout << endl;
    }*/


    int xs, ys, xt, yt;

    for(int i=0; i<q; i++)
    {
        cin >> xs >> ys >> xt >> yt;
        cout << prefix[xt][yt]-prefix[xs][ys]+table[xs][ys] << endl;
    }


    return 0;
}
