#include <iostream>
#include <cmath>
using namespace std;



int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);


    int n, m;
    cin >> n >> m;
    int q;
    cin  >> q;
    long long table[n+1][m+1];
    long long prefix[n+1][m+1];

    for(int i=1; i<=n; i++)
    {
        for(int j=1; j<=m; j++)
        {
            cin >> table[i][j];
        }
    }



    int xs, ys, xt, yt;

    for(int k=0; k<q; k++)
    {
        cin >> xs >> ys >> xt >> yt;
        prefix[xs][ys]=table[xs][ys];
        for(int j=ys+1; j<=yt; j++)
        {
            prefix[xs][j]=table[xs][j]+prefix[xs][j-1];
        }
        for(int i=xs+1; i<=xt; i++)
        {
            prefix[i][ys]=table[i][ys]+prefix[i-1][ys];
        }

        for(int i=xs+1; i<=xt; i++)
        {
            for(int j=ys+1; j<=yt; j++)
            {
                prefix[i][j]=min(prefix[i-1][j], prefix[i][j-1])+table[i][j];
            }
        }
        /*for(int i=xs; i<=xt; i++)
        {
            for(int j=ys; j<=yt; j++)
            {
                cout << prefix[i][j] << " ";
            }
            cout << endl;
        }*/

        cout << prefix[xt][yt] << endl;
    }


    return 0;
}

