#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, m, q;
    cin >> n >> m >> q;

    vector< vector<int> > num, dp;
    num.resize(n + 1);
    dp.resize(n + 1);
    for (int i = 1; i <= n; ++ i)
    {
        num[i].resize(m + 1);
        dp[i].resize(m + 1);
        for (int j = 1; j <= m; ++ j)
        {
            cin >> num[i][j];
        }
    }

    for (int i = 1; i <= q; ++ i)
    {
        int a, b, c, d;
        cin >> a >> b >> c >> d;

        dp[a][b] = num[a][b];
        for (int x = a + 1; x <= c; ++ x)
        {
            dp[x][b] = dp[x - 1][b] + num[x][b];
        }
        for (int y = b + 1; y <= d; ++ y)
        {
            dp[a][y] = dp[a][y - 1] + num[a][y];
        }

        for (int x = a + 1; x <= c; ++ x)
        {
            for (int y = b + 1; y <= d; ++ y)
            {
                dp[x][y] = min(dp[x - 1][y], dp[x][y - 1]) + num[x][y];
            }
        }
        cout << dp[c][d] << endl;
    }

    return 0;
}
