#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXQ = 200000;

int ans[MAXQ + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, m, q;
    cin >> n >> m >> q;

    vector< vector<int> > num, dp;
    vector< vector< vector< pair<int, pair<int, int> > > > > v;
    num.resize(n + 1);
    dp.resize(n + 1);
    v.resize(n + 1);
    for (int i = 1; i <= n; ++ i)
    {
        num[i].resize(m + 1);
        dp[i].resize(m + 1);
        v[i].resize(m + 1);
        for (int j = 1; j <= m; ++ j)
        {
            cin >> num[i][j];
        }
    }

    for (int i = 1; i <= q; ++ i)
    {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        v[a][b].push_back({i, {c, d}});
    }

    for (int a = 1; a <= n; ++ a)
    {
        for (int b = 1; b <= m; ++ b)
        {
            dp[a][b] = num[a][b];
            for (int x = a + 1; x <= n; ++ x)
            {
                dp[x][b] = dp[x - 1][b] + num[x][b];
            }
            for (int y = b + 1; y <= m; ++ y)
            {
                dp[a][y] = dp[a][y - 1] + num[a][y];
            }
            for (int x = a + 1; x <= n; ++ x)
            {
                for (int y = b + 1; y <= m; ++ y)
                {
                    dp[x][y] = min(dp[x - 1][y], dp[x][y - 1]) + num[x][y];
                }
            }
            for (auto [idx, q] : v[a][b])
            {
                auto [c, d] = q;
                ans[idx] = dp[c][d];
            }
        }
    }

    for (int i = 1; i <= q; ++ i)
    {
        cout << ans[i] << endl;
    }

    return 0;
}
