#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAX = 40000;
const int LOG = 16;
const long long INF = 1e18;

long long dp[10][2];
int num[10][MAX + 5];
long long st[10][MAX + 5][10][LOG + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, m, q;
    cin >> n >> m >> q;

    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            cin >> num[i][j];
        }
    }

    for (int j = 1; j <= m; ++ j)
    {
        for (int i = 1; i <= n; ++ i)
        {
            int sum = 0;
            for (int i2 = i; i2 <= n; ++ i2)
            {
                sum += num[i2][j];
                st[i][j][i2][0] = sum;
            }
        }
    }

    for (int L = 1; L <= LOG; ++ L)
    {
        for (int j = 1; j <= m; ++ j)
        {
            for (int i = 1; i <= n; ++ i)
            {
                for (int i2 = i; i2 <= n; ++ i2)
                {
                    st[i][j][i2][L] = INF;
                    for (int i1 = i; i1 <= i2; ++ i1)
                    {
                        st[i][j][i2][L] = min(st[i][j][i2][L], st[i][j][i1][L - 1] + st[i1][j + (1ll << (L - 1))][i2][L - 1]);
                    }
                }
            }
        }
    }

    while (q--)
    {
        int i, j0, i2, j1;
        cin >> i >> j0 >> i2 >> j1;

        for (int t = i; t <= i2; ++ t)
        {
            dp[t][0] = st[i][j0][t][0];
        }
        j0++;

        for (int L = LOG; L >= 0; -- L)
        {
            if (j0 + (1ll << L) - 1 <= j1)
            {
                for (int t = i; t <= i2; ++ t)
                {
                    dp[t][1] = INF;
                }
                for (int t = i; t <= i2; ++ t)
                {
                    for (int t2 = t; t2 <= i2; ++ t2)
                    {
                        dp[t2][1] = min(dp[t2][1], dp[t][0] + st[t][j0][t2][L]);
                    }
                }
                for (int t = i; t <= i2; ++ t)
                {
                    dp[t][0] = dp[t][1];
                }
                j0 += (1ll << L);
            }
        }
        cout << dp[i2][0] << endl;
    }

    return 0;
}
