#include <iostream>
#include <random>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 64;

mt19937 rg(42103301);

int cnt = 0, flag;
int pref[MAXN + 5][MAXN + 5];
vector< pair<int, int> > nodes;
int vr[MAXN + 5][MAXN + 5][MAXN + 5][MAXN + 5];

int go(int i0, int j0, int i1, int j1)
{
    if (vr[i0][j0][i1][j1] != 0) return vr[i0][j0][i1][j1];
    if (i0 == i1 or flag)
    {
        int mid = (j0 + j1) / 2;
        int a = go(i0, j0, i1, mid);
        int b = go(i0, mid + 1, i1, j1);
        cnt++;
        vr[i0][j0][i1][j1] = cnt;
        nodes.push_back({a, b});
        return cnt;
    }
    if (j0 == j1 or !flag)
    {
        int mid = (i0 + i1) / 2;
        int a = go(i0, j0, mid, j1);
        int b = go(mid + 1, j0, i1, j1);
        cnt++;
        vr[i0][j0][i1][j1] = cnt;
        nodes.push_back({a, b});
        return cnt;
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, m;
    cin >> n >> m;

    flag = rg() % 2;

    cnt = n * m;
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            vr[i][j][i][j] = (i - 1) * m + j;
        }
    }

    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            pref[i][j] = go(1, 1, i, j);
        }
    }

    cout << cnt << endl;
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            cout << pref[i][j] << " ";
        }
        cout << endl;
    }

    for (int i = 0; i < nodes.size(); ++ i)
    {
        cout << i + n * m + 1 << " = " << nodes[i].first << " + " << nodes[i].second << endl;
    }

    return 0;
}
